#include <net/eth.h>
#include <net/arp.h>
#include <net/ip.h>
#include <net/tcp.h>
#include <net/udp.h>
#include <net/icmp.h>
#include <net/in.h>
#include <net/socket.h>
#include <string.h>

#include <ip_out.h>
#include <csock.h>

/*
 * send data on socket
 * called from send()
 */

int csock_send(int s,  unsigned char* buf, unsigned int len) {
   
   struct xilnet_tcp_conn *conn;

   conn = xilsock_sockets[s].conn.tcp_conn;
   
   if (!conn) {
      print("send: no such socket \n");
      return -1;
   }

   
   memset(sendbuf, 0, LINK_FRAME_LEN);
   memcpy(sendbuf+LINK_HDR_LEN+IP_HDR_LEN*4+(TCP_HDR_LEN*4), buf, len); 

   
   xilnet_tcp_send_pkt(conn, buf+LINK_HDR_LEN+IP_HDR_LEN*4, len, TCP_ACK);
   xilnet_ip_header(buf+LINK_HDR_LEN, len+(TCP_HDR_LEN*4)+IP_HDR_LEN*4, IP_PROTO_TCP, conn->dst_ip);
   ip_output(s, buf, len+(TCP_HDR_LEN*4)+IP_HDR_LEN*4+ETH_HDR_LEN);

   return len;  
}