#ifndef IP_OUT_H
#define IP_OUT_H


#define MTU 1500
#define	IP_DF 0x4000			/* dont fragment flag */
#define	IP_MF 0x2000			/* more fragments flag */
#define	IP_OFFMASK 0x1fff		/* mask for fragmenting bits */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <net/eth.h>
#include <net/arp.h>
#include <net/ip.h>
#include <net/tcp.h>
#include <net/udp.h>
#include <net/icmp.h>
#include <net/in.h>
#include <net/socket.h>
#include <net/xilnet_config.h>
#include <net/xilsock.h>


struct frag_list
{
	struct frag_list * next;
	unsigned int data_len;		 
	unsigned char data[MTU];
};


// ip header structure
struct ip {
  unsigned char version:4,
                hdr_len:4;
  unsigned char		ip_tos;
  unsigned short	ip_len;
  unsigned short	ip_id;
  unsigned short	ip_off;
  unsigned char		ip_ttl;
  unsigned char		ip_prot;
  unsigned short	ip_sum;
  unsigned int		ip_src;
  unsigned int		ip_dst;
};

extern void ip_output(int s, unsigned char* buf, unsigned int frame_len);

#endif 