/*
 * Xilinx EDK 6.2.2 EDK_Gm.13.6
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    E:\proj\zbt_lab\lab
 */


// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"

#include "xutil.h"
#include "xgpio_l.h"

/*
 * Routine to write a pattern out to a GPIO
 * which is configured as an output
 *   PARAMETER C_ALL_INPUTS = 0
 */ 
void WriteToGPOutput(Xuint32 BaseAddress, int gpio_width) {
   int i=0, j=0, k=0;
   int numTimes = 5;
 
   XGpio_mSetDataDirection(BaseAddress, 0x00000000);   /* Set as outputs */
   while (numTimes > 0) {
      j = 1;
      for(i=0; i<(gpio_width-1); i++) {
         XGpio_mSetDataReg(BaseAddress, j);
         j = j << 1;
         for (k=0; k<1000000; k++) {
            ; //wait
         }
      }
      j = 1;
      j = ~j;
      for(i=0; i<(gpio_width-1); i++) {
         XGpio_mSetDataReg(BaseAddress, j);
         j = j << 1;
         for (k=0; k<1000000; k++) {
            ; //wait
         }
      }
      numTimes--;
   }
}


//====================================================

int main (void) {


   print("-- Entering main() --\n\r");

   /* 
    * MemoryTest routine will not be run for the memory at 
    * dlmb_cntlr.C_BASEADDR
    * because it is being used to hold a part of this application program
    */


   /* 
    * MemoryTest routine will not be run for the memory at 
    * ilmb_cntlr.C_BASEADDR
    * because it is being used to hold a part of this application program
    */


   WriteToGPOutput(XPAR_OPB_GPIO_0_BASEADDR, 2);

   /* Testing EMC Memory (ZBT_512Kx32)*/
   {
      XStatus status;

      print("Starting MemoryTest for ZBT_512Kx32 bank0:\n\r");
      print("  Running 32-bit test...");
      status = XUtil_MemoryTest32((Xuint32*)XPAR_EMC_MEM0_BASEADDR, 1024, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 16-bit test...");
      status = XUtil_MemoryTest16((Xuint16*)XPAR_EMC_MEM0_BASEADDR, 2048, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 8-bit test...");
      status = XUtil_MemoryTest8((Xuint8*)XPAR_EMC_MEM0_BASEADDR, 4096, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }

	  print("Starting MemoryTest for ZBT_512Kx32 bank1:\n\r");
      print("  Running 32-bit test...");
      status = XUtil_MemoryTest32((Xuint32*)XPAR_EMC_MEM1_BASEADDR, 1024, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 16-bit test...");
      status = XUtil_MemoryTest16((Xuint16*)XPAR_EMC_MEM1_BASEADDR, 2048, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 8-bit test...");
      status = XUtil_MemoryTest8((Xuint8*)XPAR_EMC_MEM1_BASEADDR, 4096, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }

	  print("Starting MemoryTest for ZBT_512Kx32 bank2:\n\r");
      print("  Running 32-bit test...");
      status = XUtil_MemoryTest32((Xuint32*)XPAR_EMC_MEM2_BASEADDR, 1024, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 16-bit test...");
      status = XUtil_MemoryTest16((Xuint16*)XPAR_EMC_MEM2_BASEADDR, 2048, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 8-bit test...");
      status = XUtil_MemoryTest8((Xuint8*)XPAR_EMC_MEM2_BASEADDR, 4096, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }

	  print("Starting MemoryTest for ZBT_512Kx32 bank3:\n\r");
      print("  Running 32-bit test...");
      status = XUtil_MemoryTest32((Xuint32*)XPAR_EMC_MEM3_BASEADDR, 1024, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 16-bit test...");
      status = XUtil_MemoryTest16((Xuint16*)XPAR_EMC_MEM3_BASEADDR, 2048, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 8-bit test...");
      status = XUtil_MemoryTest8((Xuint8*)XPAR_EMC_MEM3_BASEADDR, 4096, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }

	  print("Starting MemoryTest for ZBT_512Kx32 bank4:\n\r");
      print("  Running 32-bit test...");
      status = XUtil_MemoryTest32((Xuint32*)XPAR_EMC_MEM4_BASEADDR, 1024, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 16-bit test...");
      status = XUtil_MemoryTest16((Xuint16*)XPAR_EMC_MEM4_BASEADDR, 2048, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }
      print("  Running 8-bit test...");
      status = XUtil_MemoryTest8((Xuint8*)XPAR_EMC_MEM4_BASEADDR, 4096, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\n\r");
      }
      else {
         print("FAILED!\n\r");
      }


   }

   print("-- Exiting main() --\n\r");
   return 0;
}

