-------------------------------------------------------------------------------
-- clk_aligner_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library clk_align_v1_00_a;
use clk_align_v1_00_a.all;

entity clk_aligner_wrapper is
  port (
    external_clk : in std_logic;
    extend_dcm_reset : in std_logic;
    dcm0_locked : in std_logic;
    dcm1_locked : in std_logic;
    fpga_reset : out std_logic;
    dcm_reset : out std_logic
  );
end clk_aligner_wrapper;

architecture STRUCTURE of clk_aligner_wrapper is

  component clk_align is
    port (
      external_clk : in std_logic;
      extend_dcm_reset : in std_logic;
      dcm0_locked : in std_logic;
      dcm1_locked : in std_logic;
      fpga_reset : out std_logic;
      dcm_reset : out std_logic
    );
  end component;

begin

  clk_aligner : clk_align
    port map (
      external_clk => external_clk,
      extend_dcm_reset => extend_dcm_reset,
      dcm0_locked => dcm0_locked,
      dcm1_locked => dcm1_locked,
      fpga_reset => fpga_reset,
      dcm_reset => dcm_reset
    );

end architecture STRUCTURE;
