-------------------------------------------------------------------------------
-- system.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity system is
  port (
    RS232_TX : out std_logic;
    RS232_RX : in std_logic;
    opb_gpio_0_GPIO_IO : inout std_logic_vector(0 to 3);
    opb_ethernet_0_PHY_tx_data : out std_logic_vector(3 downto 0);
    opb_ethernet_0_PHY_col : in std_logic;
    opb_ethernet_0_PHY_crs : in std_logic;
    opb_ethernet_0_PHY_tx_clk : in std_logic;
    opb_ethernet_0_PHY_tx_en : out std_logic;
    opb_ethernet_0_PHY_rx_er : in std_logic;
    opb_ethernet_0_PHY_rx_data : in std_logic_vector(3 downto 0);
    opb_ethernet_0_PHY_rx_clk : in std_logic;
    opb_ethernet_0_PHY_dv : in std_logic;
    opb_ethernet_0_PHY_Mii_clk : inout std_logic;
    opb_ethernet_0_PHY_Mii_data : inout std_logic;
    opb_ethernet_0_PHY_tx_er : out std_logic;
    memory_bank2_cen_n : out std_logic;
    memory_bank2_clk : out std_logic;
    memory_bank2_clken_n : out std_logic;
    memory_bank2_data : inout std_logic_vector(0 to 31);
    memory_bank2_oen_n : out std_logic;
    memory_bank2_wen : out std_logic_vector(1 to 4);
    memory_bank2_wen_n : out std_logic;
    memory_bank3_addr_p : out std_logic_vector(0 to 18);
    memory_bank3_adv_ld_n : out std_logic;
    memory_bank3_cen_n : out std_logic;
    memory_bank3_clk : out std_logic;
    memory_bank3_clken_n : out std_logic;
    memory_bank3_data : inout std_logic_vector(0 to 31);
    memory_bank3_oen_n : out std_logic;
    memory_bank3_wen : out std_logic_vector(1 to 4);
    memory_bank3_wen_n : out std_logic;
    memory_bank4_addr_p : out std_logic_vector(0 to 18);
    memory_bank4_adv_ld_n : out std_logic;
    memory_bank4_cen_n : out std_logic;
    memory_bank4_clk : out std_logic;
    memory_bank4_clken_n : out std_logic;
    memory_bank4_data : inout std_logic_vector(0 to 31);
    memory_bank4_oen_n : out std_logic;
    memory_bank4_wen : out std_logic_vector(1 to 4);
    memory_bank4_wen_n : out std_logic;
    memory_bank2_adv_ld_n : out std_logic;
    memory_bank2_addr_p : out std_logic_vector(0 to 18);
    memory_bank1_wen_n : out std_logic;
    memory_bank1_wen : out std_logic_vector(1 to 4);
    memory_bank1_oen_n : out std_logic;
    memory_bank1_data : inout std_logic_vector(0 to 31);
    memory_bank1_clken_n : out std_logic;
    memory_bank1_clk : out std_logic;
    memory_bank1_cen_n : out std_logic;
    memory_bank1_adv_ld_n : out std_logic;
    memory_bank1_addr_p : out std_logic_vector(0 to 18);
    memory_bank0_wen_n : out std_logic;
    memory_bank0_wen : out std_logic_vector(1 to 4);
    memory_bank0_oen_n : out std_logic;
    memory_bank0_data : inout std_logic_vector(0 to 31);
    memory_bank0_clken_n : out std_logic;
    memory_bank0_clk : out std_logic;
    memory_bank0_cen_n : out std_logic;
    memory_bank0_adv_ld_n : out std_logic;
    memory_bank0_addr_p : out std_logic_vector(0 to 18);
    PHY_slew2 : out std_logic;
    sys_rst : in std_logic;
    sys_clk : in std_logic;
    RS232_req_to_send : out std_logic;
    PHY_slew1 : out std_logic;
    zbt_clk_fbin : in std_logic;
    zbt_clk_fbout : out std_logic
  );
end system;

architecture STRUCTURE of system is

  attribute box_type : STRING;

  component microblaze_0_wrapper is
    port (
      CLK : in std_logic;
      RESET : in std_logic;
      INTERRUPT : in std_logic;
      DEBUG_RST : in std_logic;
      EXT_BRK : in std_logic;
      EXT_NM_BRK : in std_logic;
      DBG_STOP : in std_logic;
      INSTR : in std_logic_vector(0 to 31);
      I_ADDRTAG : out std_logic_vector(0 to 3);
      IREADY : in std_logic;
      IWAIT : in std_logic;
      INSTR_ADDR : out std_logic_vector(0 to 31);
      IFETCH : out std_logic;
      I_AS : out std_logic;
      DATA_READ : in std_logic_vector(0 to 31);
      DREADY : in std_logic;
      DWAIT : in std_logic;
      DATA_WRITE : out std_logic_vector(0 to 31);
      DATA_ADDR : out std_logic_vector(0 to 31);
      D_ADDRTAG : out std_logic_vector(0 to 3);
      D_AS : out std_logic;
      READ_STROBE : out std_logic;
      WRITE_STROBE : out std_logic;
      BYTE_ENABLE : out std_logic_vector(0 to 3);
      DM_ABUS : out std_logic_vector(0 to 31);
      DM_BE : out std_logic_vector(0 to 3);
      DM_BUSLOCK : out std_logic;
      DM_DBUS : out std_logic_vector(0 to 31);
      DM_REQUEST : out std_logic;
      DM_RNW : out std_logic;
      DM_SELECT : out std_logic;
      DM_SEQADDR : out std_logic;
      DOPB_DBUS : in std_logic_vector(0 to 31);
      DOPB_ERRACK : in std_logic;
      DOPB_MGRANT : in std_logic;
      DOPB_RETRY : in std_logic;
      DOPB_TIMEOUT : in std_logic;
      DOPB_XFERACK : in std_logic;
      IM_ABUS : out std_logic_vector(0 to 31);
      IM_BE : out std_logic_vector(0 to 3);
      IM_BUSLOCK : out std_logic;
      IM_DBUS : out std_logic_vector(0 to 31);
      IM_REQUEST : out std_logic;
      IM_RNW : out std_logic;
      IM_SELECT : out std_logic;
      IM_SEQADDR : out std_logic;
      IOPB_DBUS : in std_logic_vector(0 to 31);
      IOPB_ERRACK : in std_logic;
      IOPB_MGRANT : in std_logic;
      IOPB_RETRY : in std_logic;
      IOPB_TIMEOUT : in std_logic;
      IOPB_XFERACK : in std_logic;
      DBG_CLK : in std_logic;
      DBG_TDI : in std_logic;
      DBG_TDO : out std_logic;
      DBG_REG_EN : in std_logic_vector(0 to 4);
      DBG_CAPTURE : in std_logic;
      DBG_UPDATE : in std_logic;
      VALID_INSTR : out std_logic;
      PC_EX : out std_logic_vector(0 to 31);
      REG_WRITE : out std_logic;
      REG_ADDR : out std_logic_vector(0 to 4);
      MSR_REG : out std_logic_vector(0 to 7);
      NEW_REG_VALUE : out std_logic_vector(0 to 31);
      PIPE_RUNNING : out std_logic;
      INTERRUPT_TAKEN : out std_logic;
      JUMP_TAKEN : out std_logic;
      PREFETCH_ADDR : out std_logic_vector(0 to 3);
      MB_Halted : out std_logic;
      Trace_Branch_Instr : out std_logic;
      Trace_Delay_Slot : out std_logic;
      Trace_Data_Address : out std_logic_vector(0 to 31);
      Trace_AS : out std_logic;
      Trace_Data_Read : out std_logic;
      Trace_Data_Write : out std_logic;
      Trace_DCache_Req : out std_logic;
      Trace_DCache_Hit : out std_logic;
      Trace_ICache_Req : out std_logic;
      Trace_ICache_Hit : out std_logic;
      Trace_Instr_EX : out std_logic_vector(0 to 31);
      FSL0_S_CLK : out std_logic;
      FSL0_S_READ : out std_logic;
      FSL0_S_DATA : in std_logic_vector(0 to 31);
      FSL0_S_CONTROL : in std_logic;
      FSL0_S_EXISTS : in std_logic;
      FSL0_M_CLK : out std_logic;
      FSL0_M_WRITE : out std_logic;
      FSL0_M_DATA : out std_logic_vector(0 to 31);
      FSL0_M_CONTROL : out std_logic;
      FSL0_M_FULL : in std_logic;
      FSL1_S_CLK : out std_logic;
      FSL1_S_READ : out std_logic;
      FSL1_S_DATA : in std_logic_vector(0 to 31);
      FSL1_S_CONTROL : in std_logic;
      FSL1_S_EXISTS : in std_logic;
      FSL1_M_CLK : out std_logic;
      FSL1_M_WRITE : out std_logic;
      FSL1_M_DATA : out std_logic_vector(0 to 31);
      FSL1_M_CONTROL : out std_logic;
      FSL1_M_FULL : in std_logic;
      FSL2_S_CLK : out std_logic;
      FSL2_S_READ : out std_logic;
      FSL2_S_DATA : in std_logic_vector(0 to 31);
      FSL2_S_CONTROL : in std_logic;
      FSL2_S_EXISTS : in std_logic;
      FSL2_M_CLK : out std_logic;
      FSL2_M_WRITE : out std_logic;
      FSL2_M_DATA : out std_logic_vector(0 to 31);
      FSL2_M_CONTROL : out std_logic;
      FSL2_M_FULL : in std_logic;
      FSL3_S_CLK : out std_logic;
      FSL3_S_READ : out std_logic;
      FSL3_S_DATA : in std_logic_vector(0 to 31);
      FSL3_S_CONTROL : in std_logic;
      FSL3_S_EXISTS : in std_logic;
      FSL3_M_CLK : out std_logic;
      FSL3_M_WRITE : out std_logic;
      FSL3_M_DATA : out std_logic_vector(0 to 31);
      FSL3_M_CONTROL : out std_logic;
      FSL3_M_FULL : in std_logic;
      FSL4_S_CLK : out std_logic;
      FSL4_S_READ : out std_logic;
      FSL4_S_DATA : in std_logic_vector(0 to 31);
      FSL4_S_CONTROL : in std_logic;
      FSL4_S_EXISTS : in std_logic;
      FSL4_M_CLK : out std_logic;
      FSL4_M_WRITE : out std_logic;
      FSL4_M_DATA : out std_logic_vector(0 to 31);
      FSL4_M_CONTROL : out std_logic;
      FSL4_M_FULL : in std_logic;
      FSL5_S_CLK : out std_logic;
      FSL5_S_READ : out std_logic;
      FSL5_S_DATA : in std_logic_vector(0 to 31);
      FSL5_S_CONTROL : in std_logic;
      FSL5_S_EXISTS : in std_logic;
      FSL5_M_CLK : out std_logic;
      FSL5_M_WRITE : out std_logic;
      FSL5_M_DATA : out std_logic_vector(0 to 31);
      FSL5_M_CONTROL : out std_logic;
      FSL5_M_FULL : in std_logic;
      FSL6_S_CLK : out std_logic;
      FSL6_S_READ : out std_logic;
      FSL6_S_DATA : in std_logic_vector(0 to 31);
      FSL6_S_CONTROL : in std_logic;
      FSL6_S_EXISTS : in std_logic;
      FSL6_M_CLK : out std_logic;
      FSL6_M_WRITE : out std_logic;
      FSL6_M_DATA : out std_logic_vector(0 to 31);
      FSL6_M_CONTROL : out std_logic;
      FSL6_M_FULL : in std_logic;
      FSL7_S_CLK : out std_logic;
      FSL7_S_READ : out std_logic;
      FSL7_S_DATA : in std_logic_vector(0 to 31);
      FSL7_S_CONTROL : in std_logic;
      FSL7_S_EXISTS : in std_logic;
      FSL7_M_CLK : out std_logic;
      FSL7_M_WRITE : out std_logic;
      FSL7_M_DATA : out std_logic_vector(0 to 31);
      FSL7_M_CONTROL : out std_logic;
      FSL7_M_FULL : in std_logic
    );
  end component;

  attribute box_type of microblaze_0_wrapper: component is "black_box";

  component mb_opb_wrapper is
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : out std_logic;
      SYS_Rst : in std_logic;
      Debug_SYS_Rst : in std_logic;
      WDT_Rst : in std_logic;
      M_ABus : in std_logic_vector(0 to 63);
      M_BE : in std_logic_vector(0 to 7);
      M_beXfer : in std_logic_vector(0 to 1);
      M_busLock : in std_logic_vector(0 to 1);
      M_DBus : in std_logic_vector(0 to 63);
      M_DBusEn : in std_logic_vector(0 to 1);
      M_DBusEn32_63 : in std_logic_vector(0 to 1);
      M_dwXfer : in std_logic_vector(0 to 1);
      M_fwXfer : in std_logic_vector(0 to 1);
      M_hwXfer : in std_logic_vector(0 to 1);
      M_request : in std_logic_vector(0 to 1);
      M_RNW : in std_logic_vector(0 to 1);
      M_select : in std_logic_vector(0 to 1);
      M_seqAddr : in std_logic_vector(0 to 1);
      Sl_beAck : in std_logic_vector(0 to 6);
      Sl_DBus : in std_logic_vector(0 to 223);
      Sl_DBusEn : in std_logic_vector(0 to 6);
      Sl_DBusEn32_63 : in std_logic_vector(0 to 6);
      Sl_errAck : in std_logic_vector(0 to 6);
      Sl_dwAck : in std_logic_vector(0 to 6);
      Sl_fwAck : in std_logic_vector(0 to 6);
      Sl_hwAck : in std_logic_vector(0 to 6);
      Sl_retry : in std_logic_vector(0 to 6);
      Sl_toutSup : in std_logic_vector(0 to 6);
      Sl_xferAck : in std_logic_vector(0 to 6);
      OPB_MRequest : out std_logic_vector(0 to 1);
      OPB_ABus : out std_logic_vector(0 to 31);
      OPB_BE : out std_logic_vector(0 to 3);
      OPB_beXfer : out std_logic;
      OPB_beAck : out std_logic;
      OPB_busLock : out std_logic;
      OPB_rdDBus : out std_logic_vector(0 to 31);
      OPB_wrDBus : out std_logic_vector(0 to 31);
      OPB_DBus : out std_logic_vector(0 to 31);
      OPB_errAck : out std_logic;
      OPB_dwAck : out std_logic;
      OPB_dwXfer : out std_logic;
      OPB_fwAck : out std_logic;
      OPB_fwXfer : out std_logic;
      OPB_hwAck : out std_logic;
      OPB_hwXfer : out std_logic;
      OPB_MGrant : out std_logic_vector(0 to 1);
      OPB_pendReq : out std_logic_vector(0 to 1);
      OPB_retry : out std_logic;
      OPB_RNW : out std_logic;
      OPB_select : out std_logic;
      OPB_seqAddr : out std_logic;
      OPB_timeout : out std_logic;
      OPB_toutSup : out std_logic;
      OPB_xferAck : out std_logic
    );
  end component;

  attribute box_type of mb_opb_wrapper: component is "black_box";

  component debug_module_wrapper is
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      Interrupt : out std_logic;
      Debug_SYS_Rst : out std_logic;
      Debug_Rst : out std_logic;
      Ext_BRK : out std_logic;
      Ext_NM_BRK : out std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      MDM_DBus : out std_logic_vector(0 to 31);
      MDM_errAck : out std_logic;
      MDM_retry : out std_logic;
      MDM_toutSup : out std_logic;
      MDM_xferAck : out std_logic;
      Dbg_Clk_0 : out std_logic;
      Dbg_TDI_0 : out std_logic;
      Dbg_TDO_0 : in std_logic;
      Dbg_Reg_En_0 : out std_logic_vector(0 to 4);
      Dbg_Capture_0 : out std_logic;
      Dbg_Update_0 : out std_logic;
      Dbg_Clk_1 : out std_logic;
      Dbg_TDI_1 : out std_logic;
      Dbg_TDO_1 : in std_logic;
      Dbg_Reg_En_1 : out std_logic_vector(0 to 4);
      Dbg_Capture_1 : out std_logic;
      Dbg_Update_1 : out std_logic;
      Dbg_Clk_2 : out std_logic;
      Dbg_TDI_2 : out std_logic;
      Dbg_TDO_2 : in std_logic;
      Dbg_Reg_En_2 : out std_logic_vector(0 to 4);
      Dbg_Capture_2 : out std_logic;
      Dbg_Update_2 : out std_logic;
      Dbg_Clk_3 : out std_logic;
      Dbg_TDI_3 : out std_logic;
      Dbg_TDO_3 : in std_logic;
      Dbg_Reg_En_3 : out std_logic_vector(0 to 4);
      Dbg_Capture_3 : out std_logic;
      Dbg_Update_3 : out std_logic;
      Dbg_Clk_4 : out std_logic;
      Dbg_TDI_4 : out std_logic;
      Dbg_TDO_4 : in std_logic;
      Dbg_Reg_En_4 : out std_logic_vector(0 to 4);
      Dbg_Capture_4 : out std_logic;
      Dbg_Update_4 : out std_logic;
      Dbg_Clk_5 : out std_logic;
      Dbg_TDI_5 : out std_logic;
      Dbg_TDO_5 : in std_logic;
      Dbg_Reg_En_5 : out std_logic_vector(0 to 4);
      Dbg_Capture_5 : out std_logic;
      Dbg_Update_5 : out std_logic;
      Dbg_Clk_6 : out std_logic;
      Dbg_TDI_6 : out std_logic;
      Dbg_TDO_6 : in std_logic;
      Dbg_Reg_En_6 : out std_logic_vector(0 to 4);
      Dbg_Capture_6 : out std_logic;
      Dbg_Update_6 : out std_logic;
      Dbg_Clk_7 : out std_logic;
      Dbg_TDI_7 : out std_logic;
      Dbg_TDO_7 : in std_logic;
      Dbg_Reg_En_7 : out std_logic_vector(0 to 4);
      Dbg_Capture_7 : out std_logic;
      Dbg_Update_7 : out std_logic;
      bscan_tdi : out std_logic;
      bscan_reset : out std_logic;
      bscan_shift : out std_logic;
      bscan_update : out std_logic;
      bscan_capture : out std_logic;
      bscan_sel1 : out std_logic;
      bscan_drck1 : out std_logic;
      bscan_tdo1 : in std_logic;
      FSL0_S_CLK : out std_logic;
      FSL0_S_READ : out std_logic;
      FSL0_S_DATA : in std_logic_vector(0 to 31);
      FSL0_S_CONTROL : in std_logic;
      FSL0_S_EXISTS : in std_logic;
      FSL0_M_CLK : out std_logic;
      FSL0_M_WRITE : out std_logic;
      FSL0_M_DATA : out std_logic_vector(0 to 31);
      FSL0_M_CONTROL : out std_logic;
      FSL0_M_FULL : in std_logic
    );
  end component;

  attribute box_type of debug_module_wrapper: component is "black_box";

  component ilmb_wrapper is
    port (
      LMB_Clk : in std_logic;
      SYS_Rst : in std_logic;
      LMB_Rst : out std_logic;
      M_ABus : in std_logic_vector(0 to 31);
      M_ReadStrobe : in std_logic;
      M_WriteStrobe : in std_logic;
      M_AddrStrobe : in std_logic;
      M_DBus : in std_logic_vector(0 to 31);
      M_BE : in std_logic_vector(0 to 3);
      Sl_DBus : in std_logic_vector(0 to 31);
      Sl_Ready : in std_logic_vector(0 to 0);
      LMB_ABus : out std_logic_vector(0 to 31);
      LMB_ReadStrobe : out std_logic;
      LMB_WriteStrobe : out std_logic;
      LMB_AddrStrobe : out std_logic;
      LMB_ReadDBus : out std_logic_vector(0 to 31);
      LMB_WriteDBus : out std_logic_vector(0 to 31);
      LMB_Ready : out std_logic;
      LMB_BE : out std_logic_vector(0 to 3)
    );
  end component;

  attribute box_type of ilmb_wrapper: component is "black_box";

  component dlmb_wrapper is
    port (
      LMB_Clk : in std_logic;
      SYS_Rst : in std_logic;
      LMB_Rst : out std_logic;
      M_ABus : in std_logic_vector(0 to 31);
      M_ReadStrobe : in std_logic;
      M_WriteStrobe : in std_logic;
      M_AddrStrobe : in std_logic;
      M_DBus : in std_logic_vector(0 to 31);
      M_BE : in std_logic_vector(0 to 3);
      Sl_DBus : in std_logic_vector(0 to 31);
      Sl_Ready : in std_logic_vector(0 to 0);
      LMB_ABus : out std_logic_vector(0 to 31);
      LMB_ReadStrobe : out std_logic;
      LMB_WriteStrobe : out std_logic;
      LMB_AddrStrobe : out std_logic;
      LMB_ReadDBus : out std_logic_vector(0 to 31);
      LMB_WriteDBus : out std_logic_vector(0 to 31);
      LMB_Ready : out std_logic;
      LMB_BE : out std_logic_vector(0 to 3)
    );
  end component;

  attribute box_type of dlmb_wrapper: component is "black_box";

  component dlmb_cntlr_wrapper is
    port (
      LMB_Clk : in std_logic;
      LMB_Rst : in std_logic;
      LMB_ABus : in std_logic_vector(0 to 31);
      LMB_WriteDBus : in std_logic_vector(0 to 31);
      LMB_AddrStrobe : in std_logic;
      LMB_ReadStrobe : in std_logic;
      LMB_WriteStrobe : in std_logic;
      LMB_BE : in std_logic_vector(0 to 3);
      Sl_DBus : out std_logic_vector(0 to 31);
      Sl_Ready : out std_logic;
      BRAM_Rst_A : out std_logic;
      BRAM_Clk_A : out std_logic;
      BRAM_EN_A : out std_logic;
      BRAM_WEN_A : out std_logic_vector(0 to 3);
      BRAM_Addr_A : out std_logic_vector(0 to 31);
      BRAM_Din_A : in std_logic_vector(0 to 31);
      BRAM_Dout_A : out std_logic_vector(0 to 31)
    );
  end component;

  attribute box_type of dlmb_cntlr_wrapper: component is "black_box";

  component ilmb_cntlr_wrapper is
    port (
      LMB_Clk : in std_logic;
      LMB_Rst : in std_logic;
      LMB_ABus : in std_logic_vector(0 to 31);
      LMB_WriteDBus : in std_logic_vector(0 to 31);
      LMB_AddrStrobe : in std_logic;
      LMB_ReadStrobe : in std_logic;
      LMB_WriteStrobe : in std_logic;
      LMB_BE : in std_logic_vector(0 to 3);
      Sl_DBus : out std_logic_vector(0 to 31);
      Sl_Ready : out std_logic;
      BRAM_Rst_A : out std_logic;
      BRAM_Clk_A : out std_logic;
      BRAM_EN_A : out std_logic;
      BRAM_WEN_A : out std_logic_vector(0 to 3);
      BRAM_Addr_A : out std_logic_vector(0 to 31);
      BRAM_Din_A : in std_logic_vector(0 to 31);
      BRAM_Dout_A : out std_logic_vector(0 to 31)
    );
  end component;

  attribute box_type of ilmb_cntlr_wrapper: component is "black_box";

  component lmb_bram_wrapper is
    port (
      BRAM_Rst_A : in std_logic;
      BRAM_Clk_A : in std_logic;
      BRAM_EN_A : in std_logic;
      BRAM_WEN_A : in std_logic_vector(0 to 3);
      BRAM_Addr_A : in std_logic_vector(0 to 31);
      BRAM_Din_A : out std_logic_vector(0 to 31);
      BRAM_Dout_A : in std_logic_vector(0 to 31);
      BRAM_Rst_B : in std_logic;
      BRAM_Clk_B : in std_logic;
      BRAM_EN_B : in std_logic;
      BRAM_WEN_B : in std_logic_vector(0 to 3);
      BRAM_Addr_B : in std_logic_vector(0 to 31);
      BRAM_Din_B : out std_logic_vector(0 to 31);
      BRAM_Dout_B : in std_logic_vector(0 to 31)
    );
  end component;

  attribute box_type of lmb_bram_wrapper: component is "black_box";

  component rs232_wrapper is
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      Interrupt : out std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      UART_DBus : out std_logic_vector(0 to 31);
      UART_errAck : out std_logic;
      UART_retry : out std_logic;
      UART_toutSup : out std_logic;
      UART_xferAck : out std_logic;
      RX : in std_logic;
      TX : out std_logic
    );
  end component;

  attribute box_type of rs232_wrapper: component is "black_box";

  component opb_gpio_0_wrapper is
    port (
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_Clk : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_Rst : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      Sln_DBus : out std_logic_vector(0 to 31);
      Sln_errAck : out std_logic;
      Sln_retry : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_xferAck : out std_logic;
      IP2INTC_Irpt : out std_logic;
      GPIO_in : in std_logic_vector(0 to 3);
      GPIO_d_out : out std_logic_vector(0 to 3);
      GPIO_t_out : out std_logic_vector(0 to 3);
      GPIO2_in : in std_logic_vector(0 to 3);
      GPIO2_d_out : out std_logic_vector(0 to 3);
      GPIO2_t_out : out std_logic_vector(0 to 3);
      GPIO_IO_I : in std_logic_vector(0 to 3);
      GPIO_IO_O : out std_logic_vector(0 to 3);
      GPIO_IO_T : out std_logic_vector(0 to 3);
      GPIO2_IO_I : in std_logic_vector(0 to 3);
      GPIO2_IO_O : out std_logic_vector(0 to 3);
      GPIO2_IO_T : out std_logic_vector(0 to 3)
    );
  end component;

  attribute box_type of opb_gpio_0_wrapper: component is "black_box";

  component opb_timer_0_wrapper is
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      TC_DBus : out std_logic_vector(0 to 31);
      TC_errAck : out std_logic;
      TC_retry : out std_logic;
      TC_toutSup : out std_logic;
      TC_xferAck : out std_logic;
      CaptureTrig0 : in std_logic;
      CaptureTrig1 : in std_logic;
      GenerateOut0 : out std_logic;
      GenerateOut1 : out std_logic;
      PWM0 : out std_logic;
      Interrupt : out std_logic;
      Freeze : in std_logic
    );
  end component;

  attribute box_type of opb_timer_0_wrapper: component is "black_box";

  component opb_intc_0_wrapper is
    port (
      OPB_Clk : in std_logic;
      Intr : in std_logic_vector(1 downto 0);
      OPB_Rst : in std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      OPB_DBus : in std_logic_vector(0 to 31);
      IntC_DBus : out std_logic_vector(0 to 31);
      IntC_errAck : out std_logic;
      IntC_retry : out std_logic;
      IntC_toutSup : out std_logic;
      IntC_xferAck : out std_logic;
      Irq : out std_logic
    );
  end component;

  attribute box_type of opb_intc_0_wrapper: component is "black_box";

  component opb_ethernet_0_wrapper is
    port (
      PHY_tx_clk : in std_logic;
      PHY_rx_clk : in std_logic;
      PHY_crs : in std_logic;
      PHY_dv : in std_logic;
      PHY_rx_data : in std_logic_vector(3 downto 0);
      PHY_col : in std_logic;
      PHY_rx_er : in std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_DBus : in std_logic_vector(0 to 31);
      OPB_errAck : in std_logic;
      OPB_BE : in std_logic_vector(0 to 3);
      OPB_MGrant : in std_logic;
      OPB_retry : in std_logic;
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      OPB_timeout : in std_logic;
      OPB_xferAck : in std_logic;
      Freeze : in std_logic;
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      PHY_tx_en : out std_logic;
      PHY_rx_en : out std_logic;
      PHY_tx_er : out std_logic;
      PHY_tx_data : out std_logic_vector(3 downto 0);
      PHY_rst_n : out std_logic;
      Sln_xferAck : out std_logic;
      Sln_errAck : out std_logic;
      Sln_retry : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_DBus : out std_logic_vector(0 to 31);
      Mn_request : out std_logic;
      Mn_busLock : out std_logic;
      Mn_select : out std_logic;
      Mn_RNW : out std_logic;
      Mn_BE : out std_logic_vector(0 to 3);
      Mn_seqAddr : out std_logic;
      Mn_ABus : out std_logic_vector(0 to 31);
      emac_intrpts : out std_logic_vector(0 to 21);
      IP2INTC_Irpt : out std_logic;
      PHY_Mii_clk_I : in std_logic;
      PHY_Mii_clk_O : out std_logic;
      PHY_Mii_clk_T : out std_logic;
      PHY_Mii_data_I : in std_logic;
      PHY_Mii_data_O : out std_logic;
      PHY_Mii_data_T : out std_logic
    );
  end component;

  attribute box_type of opb_ethernet_0_wrapper: component is "black_box";

  component dcm_sysclk_wrapper is
    port (
      RST : in std_logic;
      CLKIN : in std_logic;
      CLKFB : in std_logic;
      PSEN : in std_logic;
      PSINCDEC : in std_logic;
      PSCLK : in std_logic;
      DSSEN : in std_logic;
      CLK0 : out std_logic;
      CLK90 : out std_logic;
      CLK180 : out std_logic;
      CLK270 : out std_logic;
      CLKDV : out std_logic;
      CLK2X : out std_logic;
      CLK2X180 : out std_logic;
      CLKFX : out std_logic;
      CLKFX180 : out std_logic;
      STATUS : out std_logic_vector(7 downto 0);
      LOCKED : out std_logic;
      PSDONE : out std_logic
    );
  end component;

  attribute box_type of dcm_sysclk_wrapper: component is "black_box";

  component emc_wrapper is
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      OPB_ABus : in std_logic_vector(0 to 31);
      OPB_DBus : in std_logic_vector(0 to 31);
      Sln_DBus : out std_logic_vector(0 to 31);
      OPB_select : in std_logic;
      OPB_RNW : in std_logic;
      OPB_seqAddr : in std_logic;
      OPB_BE : in std_logic_vector(0 to 3);
      Sln_xferAck : out std_logic;
      Sln_errAck : out std_logic;
      Sln_toutSup : out std_logic;
      Sln_retry : out std_logic;
      Mem_A : out std_logic_vector(0 to 31);
      Mem_DQ_I : in std_logic_vector(0 to 31);
      Mem_DQ_O : out std_logic_vector(0 to 31);
      Mem_DQ_T : out std_logic_vector(0 to 31);
      Mem_CEN : out std_logic_vector(0 to 4);
      Mem_OEN : out std_logic_vector(0 to 4);
      Mem_WEN : out std_logic;
      Mem_QWEN : out std_logic_vector(0 to 3);
      Mem_BEN : out std_logic_vector(0 to 3);
      Mem_RPN : out std_logic;
      Mem_CE : out std_logic_vector(0 to 4);
      Mem_ADV_LDN : out std_logic;
      Mem_LBON : out std_logic;
      Mem_CKEN : out std_logic;
      Mem_RNW : out std_logic
    );
  end component;

  attribute box_type of emc_wrapper: component is "black_box";

  component dcm_memclk_wrapper is
    port (
      RST : in std_logic;
      CLKIN : in std_logic;
      CLKFB : in std_logic;
      PSEN : in std_logic;
      PSINCDEC : in std_logic;
      PSCLK : in std_logic;
      DSSEN : in std_logic;
      CLK0 : out std_logic;
      CLK90 : out std_logic;
      CLK180 : out std_logic;
      CLK270 : out std_logic;
      CLKDV : out std_logic;
      CLK2X : out std_logic;
      CLK2X180 : out std_logic;
      CLKFX : out std_logic;
      CLKFX180 : out std_logic;
      STATUS : out std_logic_vector(7 downto 0);
      LOCKED : out std_logic;
      PSDONE : out std_logic
    );
  end component;

  attribute box_type of dcm_memclk_wrapper: component is "black_box";

  component zbt_access_ctrl_wrapper is
    port (
      Mem_CLK : in std_logic;
      emc_Mem_A : in std_logic_vector(0 to 31);
      emc_Mem_DQ_I : in std_logic_vector(0 to 31);
      emc_Mem_DQ_O : out std_logic_vector(0 to 31);
      emc_Mem_DQ_T : in std_logic_vector(0 to 31);
      emc_Mem_CEN : in std_logic_vector(0 to 4);
      emc_Mem_OEN : in std_logic_vector(0 to 4);
      emc_Mem_WEN : in std_logic;
      emc_Mem_BEN : in std_logic_vector(0 to 3);
      emc_Mem_ADV_LDN : in std_logic;
      emc_Mem_CKEN : in std_logic;
      bank0_Mem_CLK : out std_logic;
      bank0_Mem_A : out std_logic_vector(18 downto 0);
      bank0_Mem_CEN : out std_logic;
      bank0_Mem_OEN : out std_logic;
      bank0_Mem_WEN : out std_logic;
      bank0_Mem_BEN : out std_logic_vector(0 to 3);
      bank0_Mem_ADV_LDN : out std_logic;
      bank0_Mem_CKEN : out std_logic;
      bank1_Mem_CLK : out std_logic;
      bank1_Mem_A : out std_logic_vector(18 downto 0);
      bank1_Mem_CEN : out std_logic;
      bank1_Mem_OEN : out std_logic;
      bank1_Mem_WEN : out std_logic;
      bank1_Mem_BEN : out std_logic_vector(0 to 3);
      bank1_Mem_ADV_LDN : out std_logic;
      bank1_Mem_CKEN : out std_logic;
      bank2_Mem_CLK : out std_logic;
      bank2_Mem_A : out std_logic_vector(18 downto 0);
      bank2_Mem_CEN : out std_logic;
      bank2_Mem_OEN : out std_logic;
      bank2_Mem_WEN : out std_logic;
      bank2_Mem_BEN : out std_logic_vector(0 to 3);
      bank2_Mem_ADV_LDN : out std_logic;
      bank2_Mem_CKEN : out std_logic;
      bank3_Mem_CLK : out std_logic;
      bank3_Mem_A : out std_logic_vector(18 downto 0);
      bank3_Mem_CEN : out std_logic;
      bank3_Mem_OEN : out std_logic;
      bank3_Mem_WEN : out std_logic;
      bank3_Mem_BEN : out std_logic_vector(0 to 3);
      bank3_Mem_ADV_LDN : out std_logic;
      bank3_Mem_CKEN : out std_logic;
      bank4_Mem_CLK : out std_logic;
      bank4_Mem_A : out std_logic_vector(18 downto 0);
      bank4_Mem_CEN : out std_logic;
      bank4_Mem_OEN : out std_logic;
      bank4_Mem_WEN : out std_logic;
      bank4_Mem_BEN : out std_logic_vector(0 to 3);
      bank4_Mem_ADV_LDN : out std_logic;
      bank4_Mem_CKEN : out std_logic;
      bank0_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank0_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank0_Mem_DQ_T : out std_logic_vector(0 to 31);
      bank1_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank1_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank1_Mem_DQ_T : out std_logic_vector(0 to 31);
      bank2_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank2_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank2_Mem_DQ_T : out std_logic_vector(0 to 31);
      bank3_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank3_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank3_Mem_DQ_T : out std_logic_vector(0 to 31);
      bank4_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank4_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank4_Mem_DQ_T : out std_logic_vector(0 to 31)
    );
  end component;

  attribute box_type of zbt_access_ctrl_wrapper: component is "black_box";

  component clk_aligner_wrapper is
    port (
      external_clk : in std_logic;
      extend_dcm_reset : in std_logic;
      dcm0_locked : in std_logic;
      dcm1_locked : in std_logic;
      fpga_reset : out std_logic;
      dcm_reset : out std_logic
    );
  end component;

  attribute box_type of clk_aligner_wrapper: component is "black_box";

  component OBUF is
    port (
      I : in std_logic;
      O : out std_logic
    );
  end component;

  component IBUF is
    port (
      I : in std_logic;
      O : out std_logic
    );
  end component;

  component IOBUF is
    port (
      I : in std_logic;
      IO : inout std_logic;
      O : out std_logic;
      T : in std_logic
    );
  end component;

  component BUFGP is
    port (
      I : in std_logic;
      O : out std_logic
    );
  end component;

  -- Internal signals

  signal Dbg_Capture : std_logic;
  signal Dbg_Clk : std_logic;
  signal Dbg_Reg_En : std_logic_vector(0 to 4);
  signal Dbg_TDI : std_logic;
  signal Dbg_TDO : std_logic;
  signal Dbg_Update : std_logic;
  signal Debug_Rst : std_logic;
  signal Ext_BRK : std_logic;
  signal Ext_NM_BRK : std_logic;
  signal INT_out : std_logic;
  signal RS232_RX_IBUF : std_logic;
  signal RS232_TX_OBUF : std_logic;
  signal dcm_clk_27mhz : std_logic;
  signal dcm_clk_81mhz : std_logic;
  signal dcm_memclk_locked : std_logic;
  signal dcm_reset : std_logic;
  signal dcm_sysclk_locked : std_logic;
  signal dlmb_LMB_ABus : std_logic_vector(0 to 31);
  signal dlmb_LMB_AddrStrobe : std_logic;
  signal dlmb_LMB_BE : std_logic_vector(0 to 3);
  signal dlmb_LMB_ReadDBus : std_logic_vector(0 to 31);
  signal dlmb_LMB_ReadStrobe : std_logic;
  signal dlmb_LMB_Ready : std_logic;
  signal dlmb_LMB_WriteDBus : std_logic_vector(0 to 31);
  signal dlmb_LMB_WriteStrobe : std_logic;
  signal dlmb_M_ABus : std_logic_vector(0 to 31);
  signal dlmb_M_AddrStrobe : std_logic;
  signal dlmb_M_BE : std_logic_vector(0 to 3);
  signal dlmb_M_DBus : std_logic_vector(0 to 31);
  signal dlmb_M_ReadStrobe : std_logic;
  signal dlmb_M_WriteStrobe : std_logic;
  signal dlmb_OPB_Rst : std_logic;
  signal dlmb_Sl_DBus : std_logic_vector(0 to 31);
  signal dlmb_Sl_Ready : std_logic_vector(0 to 0);
  signal dlmb_port_BRAM_Addr : std_logic_vector(0 to 31);
  signal dlmb_port_BRAM_Clk : std_logic;
  signal dlmb_port_BRAM_Din : std_logic_vector(0 to 31);
  signal dlmb_port_BRAM_Dout : std_logic_vector(0 to 31);
  signal dlmb_port_BRAM_EN : std_logic;
  signal dlmb_port_BRAM_Rst : std_logic;
  signal dlmb_port_BRAM_WEN : std_logic_vector(0 to 3);
  signal emac_intr : std_logic;
  signal emc_Mem_A : std_logic_vector(0 to 31);
  signal emc_Mem_ADV_LDN : std_logic;
  signal emc_Mem_BEN : std_logic_vector(0 to 3);
  signal emc_Mem_CEN : std_logic_vector(0 to 4);
  signal emc_Mem_CKEN : std_logic;
  signal emc_Mem_DQ_I : std_logic_vector(0 to 31);
  signal emc_Mem_DQ_O : std_logic_vector(0 to 31);
  signal emc_Mem_DQ_T : std_logic_vector(0 to 31);
  signal emc_Mem_OEN : std_logic_vector(0 to 4);
  signal emc_Mem_WEN : std_logic;
  signal fpga_reset : std_logic;
  signal ilmb_LMB_ABus : std_logic_vector(0 to 31);
  signal ilmb_LMB_AddrStrobe : std_logic;
  signal ilmb_LMB_BE : std_logic_vector(0 to 3);
  signal ilmb_LMB_ReadDBus : std_logic_vector(0 to 31);
  signal ilmb_LMB_ReadStrobe : std_logic;
  signal ilmb_LMB_Ready : std_logic;
  signal ilmb_LMB_WriteDBus : std_logic_vector(0 to 31);
  signal ilmb_LMB_WriteStrobe : std_logic;
  signal ilmb_M_ABus : std_logic_vector(0 to 31);
  signal ilmb_M_AddrStrobe : std_logic;
  signal ilmb_M_ReadStrobe : std_logic;
  signal ilmb_OPB_Rst : std_logic;
  signal ilmb_Sl_DBus : std_logic_vector(0 to 31);
  signal ilmb_Sl_Ready : std_logic_vector(0 to 0);
  signal ilmb_port_BRAM_Addr : std_logic_vector(0 to 31);
  signal ilmb_port_BRAM_Clk : std_logic;
  signal ilmb_port_BRAM_Din : std_logic_vector(0 to 31);
  signal ilmb_port_BRAM_Dout : std_logic_vector(0 to 31);
  signal ilmb_port_BRAM_EN : std_logic;
  signal ilmb_port_BRAM_Rst : std_logic;
  signal ilmb_port_BRAM_WEN : std_logic_vector(0 to 3);
  signal mb_opb_Debug_SYS_Rst : std_logic;
  signal mb_opb_M_ABus : std_logic_vector(0 to 63);
  signal mb_opb_M_BE : std_logic_vector(0 to 7);
  signal mb_opb_M_DBus : std_logic_vector(0 to 63);
  signal mb_opb_M_RNW : std_logic_vector(0 to 1);
  signal mb_opb_M_busLock : std_logic_vector(0 to 1);
  signal mb_opb_M_request : std_logic_vector(0 to 1);
  signal mb_opb_M_select : std_logic_vector(0 to 1);
  signal mb_opb_M_seqAddr : std_logic_vector(0 to 1);
  signal mb_opb_OPB_ABus : std_logic_vector(0 to 31);
  signal mb_opb_OPB_BE : std_logic_vector(0 to 3);
  signal mb_opb_OPB_DBus : std_logic_vector(0 to 31);
  signal mb_opb_OPB_MGrant : std_logic_vector(0 to 1);
  signal mb_opb_OPB_RNW : std_logic;
  signal mb_opb_OPB_Rst : std_logic;
  signal mb_opb_OPB_errAck : std_logic;
  signal mb_opb_OPB_retry : std_logic;
  signal mb_opb_OPB_select : std_logic;
  signal mb_opb_OPB_seqAddr : std_logic;
  signal mb_opb_OPB_timeout : std_logic;
  signal mb_opb_OPB_xferAck : std_logic;
  signal mb_opb_Sl_DBus : std_logic_vector(0 to 223);
  signal mb_opb_Sl_errAck : std_logic_vector(0 to 6);
  signal mb_opb_Sl_retry : std_logic_vector(0 to 6);
  signal mb_opb_Sl_toutSup : std_logic_vector(0 to 6);
  signal mb_opb_Sl_xferAck : std_logic_vector(0 to 6);
  signal mem_clk_fbin : std_logic;
  signal mem_clk_fbout : std_logic;
  signal memory_bank0_addr_p_OBUF : std_logic_vector(0 to 18);
  signal memory_bank0_adv_ld_n_OBUF : std_logic;
  signal memory_bank0_cen_n_OBUF : std_logic;
  signal memory_bank0_clk_OBUF : std_logic;
  signal memory_bank0_clken_n_OBUF : std_logic;
  signal memory_bank0_data_I : std_logic_vector(0 to 31);
  signal memory_bank0_data_O : std_logic_vector(0 to 31);
  signal memory_bank0_data_T : std_logic_vector(0 to 31);
  signal memory_bank0_oen_n_OBUF : std_logic;
  signal memory_bank0_wen_OBUF : std_logic_vector(1 to 4);
  signal memory_bank0_wen_n_OBUF : std_logic;
  signal memory_bank1_addr_p_OBUF : std_logic_vector(0 to 18);
  signal memory_bank1_adv_ld_n_OBUF : std_logic;
  signal memory_bank1_cen_n_OBUF : std_logic;
  signal memory_bank1_clk_OBUF : std_logic;
  signal memory_bank1_clken_n_OBUF : std_logic;
  signal memory_bank1_data_I : std_logic_vector(0 to 31);
  signal memory_bank1_data_O : std_logic_vector(0 to 31);
  signal memory_bank1_data_T : std_logic_vector(0 to 31);
  signal memory_bank1_oen_n_OBUF : std_logic;
  signal memory_bank1_wen_OBUF : std_logic_vector(1 to 4);
  signal memory_bank1_wen_n_OBUF : std_logic;
  signal memory_bank2_addr_p_OBUF : std_logic_vector(0 to 18);
  signal memory_bank2_adv_ld_n_OBUF : std_logic;
  signal memory_bank2_cen_n_OBUF : std_logic;
  signal memory_bank2_clk_OBUF : std_logic;
  signal memory_bank2_clken_n_OBUF : std_logic;
  signal memory_bank2_data_I : std_logic_vector(0 to 31);
  signal memory_bank2_data_O : std_logic_vector(0 to 31);
  signal memory_bank2_data_T : std_logic_vector(0 to 31);
  signal memory_bank2_oen_n_OBUF : std_logic;
  signal memory_bank2_wen_OBUF : std_logic_vector(1 to 4);
  signal memory_bank2_wen_n_OBUF : std_logic;
  signal memory_bank3_addr_p_OBUF : std_logic_vector(0 to 18);
  signal memory_bank3_adv_ld_n_OBUF : std_logic;
  signal memory_bank3_cen_n_OBUF : std_logic;
  signal memory_bank3_clk_OBUF : std_logic;
  signal memory_bank3_clken_n_OBUF : std_logic;
  signal memory_bank3_data_I : std_logic_vector(0 to 31);
  signal memory_bank3_data_O : std_logic_vector(0 to 31);
  signal memory_bank3_data_T : std_logic_vector(0 to 31);
  signal memory_bank3_oen_n_OBUF : std_logic;
  signal memory_bank3_wen_OBUF : std_logic_vector(1 to 4);
  signal memory_bank3_wen_n_OBUF : std_logic;
  signal memory_bank4_addr_p_OBUF : std_logic_vector(0 to 18);
  signal memory_bank4_adv_ld_n_OBUF : std_logic;
  signal memory_bank4_cen_n_OBUF : std_logic;
  signal memory_bank4_clk_OBUF : std_logic;
  signal memory_bank4_clken_n_OBUF : std_logic;
  signal memory_bank4_data_I : std_logic_vector(0 to 31);
  signal memory_bank4_data_O : std_logic_vector(0 to 31);
  signal memory_bank4_data_T : std_logic_vector(0 to 31);
  signal memory_bank4_oen_n_OBUF : std_logic;
  signal memory_bank4_wen_OBUF : std_logic_vector(1 to 4);
  signal memory_bank4_wen_n_OBUF : std_logic;
  signal net_gnd0 : std_logic;
  signal net_gnd2 : std_logic_vector(0 to 1);
  signal net_gnd32 : std_logic_vector(0 to 31);
  signal net_gnd4 : std_logic_vector(0 to 3);
  signal net_gnd7 : std_logic_vector(0 to 6);
  signal net_vcc0 : std_logic;
  signal net_vcc2 : std_logic_vector(0 to 1);
  signal net_vcc7 : std_logic_vector(0 to 6);
  signal opb_ethernet_0_PHY_Mii_clk_I : std_logic;
  signal opb_ethernet_0_PHY_Mii_clk_O : std_logic;
  signal opb_ethernet_0_PHY_Mii_clk_T : std_logic;
  signal opb_ethernet_0_PHY_Mii_data_I : std_logic;
  signal opb_ethernet_0_PHY_Mii_data_O : std_logic;
  signal opb_ethernet_0_PHY_Mii_data_T : std_logic;
  signal opb_ethernet_0_PHY_col_IBUF : std_logic;
  signal opb_ethernet_0_PHY_crs_IBUF : std_logic;
  signal opb_ethernet_0_PHY_dv_IBUF : std_logic;
  signal opb_ethernet_0_PHY_rx_clk_IBUF : std_logic;
  signal opb_ethernet_0_PHY_rx_data_IBUF : std_logic_vector(3 downto 0);
  signal opb_ethernet_0_PHY_rx_er_IBUF : std_logic;
  signal opb_ethernet_0_PHY_tx_clk_IBUF : std_logic;
  signal opb_ethernet_0_PHY_tx_data_OBUF : std_logic_vector(3 downto 0);
  signal opb_ethernet_0_PHY_tx_en_OBUF : std_logic;
  signal opb_ethernet_0_PHY_tx_er_OBUF : std_logic;
  signal opb_gpio_0_GPIO_IO_I : std_logic_vector(0 to 3);
  signal opb_gpio_0_GPIO_IO_O : std_logic_vector(0 to 3);
  signal opb_gpio_0_GPIO_IO_T : std_logic_vector(0 to 3);
  signal pgassign1 : std_logic_vector(1 downto 0);
  signal sys_clk_s : std_logic;
  signal timer_out : std_logic;

begin

  -- Internal assignments

  pgassign1(1) <= timer_out;
  pgassign1(0) <= emac_intr;
  net_gnd0 <= '0';
  net_gnd2(0 to 1) <= B"00";
  net_gnd32(0 to 31) <= B"00000000000000000000000000000000";
  net_gnd4(0 to 3) <= B"0000";
  net_gnd7(0 to 6) <= B"0000000";
  net_vcc0 <= '1';
  net_vcc2(0 to 1) <= B"11";
  net_vcc7(0 to 6) <= B"1111111";

  microblaze_0 : microblaze_0_wrapper
    port map (
      CLK => dcm_clk_81mhz,
      RESET => mb_opb_OPB_Rst,
      INTERRUPT => INT_out,
      DEBUG_RST => Debug_Rst,
      EXT_BRK => Ext_BRK,
      EXT_NM_BRK => Ext_NM_BRK,
      DBG_STOP => net_gnd0,
      INSTR => ilmb_LMB_ReadDBus,
      I_ADDRTAG => open,
      IREADY => ilmb_LMB_Ready,
      IWAIT => net_gnd0,
      INSTR_ADDR => ilmb_M_ABus,
      IFETCH => ilmb_M_ReadStrobe,
      I_AS => ilmb_M_AddrStrobe,
      DATA_READ => dlmb_LMB_ReadDBus,
      DREADY => dlmb_LMB_Ready,
      DWAIT => net_gnd0,
      DATA_WRITE => dlmb_M_DBus,
      DATA_ADDR => dlmb_M_ABus,
      D_ADDRTAG => open,
      D_AS => dlmb_M_AddrStrobe,
      READ_STROBE => dlmb_M_ReadStrobe,
      WRITE_STROBE => dlmb_M_WriteStrobe,
      BYTE_ENABLE => dlmb_M_BE,
      DM_ABUS => mb_opb_M_ABus(0 to 31),
      DM_BE => mb_opb_M_BE(0 to 3),
      DM_BUSLOCK => mb_opb_M_busLock(0),
      DM_DBUS => mb_opb_M_DBus(0 to 31),
      DM_REQUEST => mb_opb_M_request(0),
      DM_RNW => mb_opb_M_RNW(0),
      DM_SELECT => mb_opb_M_select(0),
      DM_SEQADDR => mb_opb_M_seqAddr(0),
      DOPB_DBUS => mb_opb_OPB_DBus,
      DOPB_ERRACK => mb_opb_OPB_errAck,
      DOPB_MGRANT => mb_opb_OPB_MGrant(0),
      DOPB_RETRY => mb_opb_OPB_retry,
      DOPB_TIMEOUT => mb_opb_OPB_timeout,
      DOPB_XFERACK => mb_opb_OPB_xferAck,
      IM_ABUS => mb_opb_M_ABus(32 to 63),
      IM_BE => mb_opb_M_BE(4 to 7),
      IM_BUSLOCK => mb_opb_M_busLock(1),
      IM_DBUS => mb_opb_M_DBus(32 to 63),
      IM_REQUEST => mb_opb_M_request(1),
      IM_RNW => mb_opb_M_RNW(1),
      IM_SELECT => mb_opb_M_select(1),
      IM_SEQADDR => mb_opb_M_seqAddr(1),
      IOPB_DBUS => mb_opb_OPB_DBus,
      IOPB_ERRACK => mb_opb_OPB_errAck,
      IOPB_MGRANT => mb_opb_OPB_MGrant(1),
      IOPB_RETRY => mb_opb_OPB_retry,
      IOPB_TIMEOUT => mb_opb_OPB_timeout,
      IOPB_XFERACK => mb_opb_OPB_xferAck,
      DBG_CLK => Dbg_Clk,
      DBG_TDI => Dbg_TDI,
      DBG_TDO => Dbg_TDO,
      DBG_REG_EN => Dbg_Reg_En,
      DBG_CAPTURE => Dbg_Capture,
      DBG_UPDATE => Dbg_Update,
      VALID_INSTR => open,
      PC_EX => open,
      REG_WRITE => open,
      REG_ADDR => open,
      MSR_REG => open,
      NEW_REG_VALUE => open,
      PIPE_RUNNING => open,
      INTERRUPT_TAKEN => open,
      JUMP_TAKEN => open,
      PREFETCH_ADDR => open,
      MB_Halted => open,
      Trace_Branch_Instr => open,
      Trace_Delay_Slot => open,
      Trace_Data_Address => open,
      Trace_AS => open,
      Trace_Data_Read => open,
      Trace_Data_Write => open,
      Trace_DCache_Req => open,
      Trace_DCache_Hit => open,
      Trace_ICache_Req => open,
      Trace_ICache_Hit => open,
      Trace_Instr_EX => open,
      FSL0_S_CLK => open,
      FSL0_S_READ => open,
      FSL0_S_DATA => net_gnd32,
      FSL0_S_CONTROL => net_gnd0,
      FSL0_S_EXISTS => net_gnd0,
      FSL0_M_CLK => open,
      FSL0_M_WRITE => open,
      FSL0_M_DATA => open,
      FSL0_M_CONTROL => open,
      FSL0_M_FULL => net_gnd0,
      FSL1_S_CLK => open,
      FSL1_S_READ => open,
      FSL1_S_DATA => net_gnd32,
      FSL1_S_CONTROL => net_gnd0,
      FSL1_S_EXISTS => net_gnd0,
      FSL1_M_CLK => open,
      FSL1_M_WRITE => open,
      FSL1_M_DATA => open,
      FSL1_M_CONTROL => open,
      FSL1_M_FULL => net_gnd0,
      FSL2_S_CLK => open,
      FSL2_S_READ => open,
      FSL2_S_DATA => net_gnd32,
      FSL2_S_CONTROL => net_gnd0,
      FSL2_S_EXISTS => net_gnd0,
      FSL2_M_CLK => open,
      FSL2_M_WRITE => open,
      FSL2_M_DATA => open,
      FSL2_M_CONTROL => open,
      FSL2_M_FULL => net_gnd0,
      FSL3_S_CLK => open,
      FSL3_S_READ => open,
      FSL3_S_DATA => net_gnd32,
      FSL3_S_CONTROL => net_gnd0,
      FSL3_S_EXISTS => net_gnd0,
      FSL3_M_CLK => open,
      FSL3_M_WRITE => open,
      FSL3_M_DATA => open,
      FSL3_M_CONTROL => open,
      FSL3_M_FULL => net_gnd0,
      FSL4_S_CLK => open,
      FSL4_S_READ => open,
      FSL4_S_DATA => net_gnd32,
      FSL4_S_CONTROL => net_gnd0,
      FSL4_S_EXISTS => net_gnd0,
      FSL4_M_CLK => open,
      FSL4_M_WRITE => open,
      FSL4_M_DATA => open,
      FSL4_M_CONTROL => open,
      FSL4_M_FULL => net_gnd0,
      FSL5_S_CLK => open,
      FSL5_S_READ => open,
      FSL5_S_DATA => net_gnd32,
      FSL5_S_CONTROL => net_gnd0,
      FSL5_S_EXISTS => net_gnd0,
      FSL5_M_CLK => open,
      FSL5_M_WRITE => open,
      FSL5_M_DATA => open,
      FSL5_M_CONTROL => open,
      FSL5_M_FULL => net_gnd0,
      FSL6_S_CLK => open,
      FSL6_S_READ => open,
      FSL6_S_DATA => net_gnd32,
      FSL6_S_CONTROL => net_gnd0,
      FSL6_S_EXISTS => net_gnd0,
      FSL6_M_CLK => open,
      FSL6_M_WRITE => open,
      FSL6_M_DATA => open,
      FSL6_M_CONTROL => open,
      FSL6_M_FULL => net_gnd0,
      FSL7_S_CLK => open,
      FSL7_S_READ => open,
      FSL7_S_DATA => net_gnd32,
      FSL7_S_CONTROL => net_gnd0,
      FSL7_S_EXISTS => net_gnd0,
      FSL7_M_CLK => open,
      FSL7_M_WRITE => open,
      FSL7_M_DATA => open,
      FSL7_M_CONTROL => open,
      FSL7_M_FULL => net_gnd0
    );

  mb_opb : mb_opb_wrapper
    port map (
      OPB_Clk => dcm_clk_81mhz,
      OPB_Rst => mb_opb_OPB_Rst,
      SYS_Rst => fpga_reset,
      Debug_SYS_Rst => mb_opb_Debug_SYS_Rst,
      WDT_Rst => net_gnd0,
      M_ABus => mb_opb_M_ABus,
      M_BE => mb_opb_M_BE,
      M_beXfer => net_gnd2,
      M_busLock => mb_opb_M_busLock,
      M_DBus => mb_opb_M_DBus,
      M_DBusEn => net_gnd2,
      M_DBusEn32_63 => net_vcc2,
      M_dwXfer => net_gnd2,
      M_fwXfer => net_gnd2,
      M_hwXfer => net_gnd2,
      M_request => mb_opb_M_request,
      M_RNW => mb_opb_M_RNW,
      M_select => mb_opb_M_select,
      M_seqAddr => mb_opb_M_seqAddr,
      Sl_beAck => net_gnd7,
      Sl_DBus => mb_opb_Sl_DBus,
      Sl_DBusEn => net_vcc7,
      Sl_DBusEn32_63 => net_vcc7,
      Sl_errAck => mb_opb_Sl_errAck,
      Sl_dwAck => net_gnd7,
      Sl_fwAck => net_gnd7,
      Sl_hwAck => net_gnd7,
      Sl_retry => mb_opb_Sl_retry,
      Sl_toutSup => mb_opb_Sl_toutSup,
      Sl_xferAck => mb_opb_Sl_xferAck,
      OPB_MRequest => open,
      OPB_ABus => mb_opb_OPB_ABus,
      OPB_BE => mb_opb_OPB_BE,
      OPB_beXfer => open,
      OPB_beAck => open,
      OPB_busLock => open,
      OPB_rdDBus => open,
      OPB_wrDBus => open,
      OPB_DBus => mb_opb_OPB_DBus,
      OPB_errAck => mb_opb_OPB_errAck,
      OPB_dwAck => open,
      OPB_dwXfer => open,
      OPB_fwAck => open,
      OPB_fwXfer => open,
      OPB_hwAck => open,
      OPB_hwXfer => open,
      OPB_MGrant => mb_opb_OPB_MGrant,
      OPB_pendReq => open,
      OPB_retry => mb_opb_OPB_retry,
      OPB_RNW => mb_opb_OPB_RNW,
      OPB_select => mb_opb_OPB_select,
      OPB_seqAddr => mb_opb_OPB_seqAddr,
      OPB_timeout => mb_opb_OPB_timeout,
      OPB_toutSup => open,
      OPB_xferAck => mb_opb_OPB_xferAck
    );

  debug_module : debug_module_wrapper
    port map (
      OPB_Clk => dcm_clk_81mhz,
      OPB_Rst => mb_opb_OPB_Rst,
      Interrupt => open,
      Debug_SYS_Rst => mb_opb_Debug_SYS_Rst,
      Debug_Rst => Debug_Rst,
      Ext_BRK => Ext_BRK,
      Ext_NM_BRK => Ext_NM_BRK,
      OPB_ABus => mb_opb_OPB_ABus,
      OPB_BE => mb_opb_OPB_BE,
      OPB_RNW => mb_opb_OPB_RNW,
      OPB_select => mb_opb_OPB_select,
      OPB_seqAddr => mb_opb_OPB_seqAddr,
      OPB_DBus => mb_opb_OPB_DBus,
      MDM_DBus => mb_opb_Sl_DBus(0 to 31),
      MDM_errAck => mb_opb_Sl_errAck(0),
      MDM_retry => mb_opb_Sl_retry(0),
      MDM_toutSup => mb_opb_Sl_toutSup(0),
      MDM_xferAck => mb_opb_Sl_xferAck(0),
      Dbg_Clk_0 => Dbg_Clk,
      Dbg_TDI_0 => Dbg_TDI,
      Dbg_TDO_0 => Dbg_TDO,
      Dbg_Reg_En_0 => Dbg_Reg_En,
      Dbg_Capture_0 => Dbg_Capture,
      Dbg_Update_0 => Dbg_Update,
      Dbg_Clk_1 => open,
      Dbg_TDI_1 => open,
      Dbg_TDO_1 => net_gnd0,
      Dbg_Reg_En_1 => open,
      Dbg_Capture_1 => open,
      Dbg_Update_1 => open,
      Dbg_Clk_2 => open,
      Dbg_TDI_2 => open,
      Dbg_TDO_2 => net_gnd0,
      Dbg_Reg_En_2 => open,
      Dbg_Capture_2 => open,
      Dbg_Update_2 => open,
      Dbg_Clk_3 => open,
      Dbg_TDI_3 => open,
      Dbg_TDO_3 => net_gnd0,
      Dbg_Reg_En_3 => open,
      Dbg_Capture_3 => open,
      Dbg_Update_3 => open,
      Dbg_Clk_4 => open,
      Dbg_TDI_4 => open,
      Dbg_TDO_4 => net_gnd0,
      Dbg_Reg_En_4 => open,
      Dbg_Capture_4 => open,
      Dbg_Update_4 => open,
      Dbg_Clk_5 => open,
      Dbg_TDI_5 => open,
      Dbg_TDO_5 => net_gnd0,
      Dbg_Reg_En_5 => open,
      Dbg_Capture_5 => open,
      Dbg_Update_5 => open,
      Dbg_Clk_6 => open,
      Dbg_TDI_6 => open,
      Dbg_TDO_6 => net_gnd0,
      Dbg_Reg_En_6 => open,
      Dbg_Capture_6 => open,
      Dbg_Update_6 => open,
      Dbg_Clk_7 => open,
      Dbg_TDI_7 => open,
      Dbg_TDO_7 => net_gnd0,
      Dbg_Reg_En_7 => open,
      Dbg_Capture_7 => open,
      Dbg_Update_7 => open,
      bscan_tdi => open,
      bscan_reset => open,
      bscan_shift => open,
      bscan_update => open,
      bscan_capture => open,
      bscan_sel1 => open,
      bscan_drck1 => open,
      bscan_tdo1 => net_gnd0,
      FSL0_S_CLK => open,
      FSL0_S_READ => open,
      FSL0_S_DATA => net_gnd32,
      FSL0_S_CONTROL => net_gnd0,
      FSL0_S_EXISTS => net_gnd0,
      FSL0_M_CLK => open,
      FSL0_M_WRITE => open,
      FSL0_M_DATA => open,
      FSL0_M_CONTROL => open,
      FSL0_M_FULL => net_gnd0
    );

  ilmb : ilmb_wrapper
    port map (
      LMB_Clk => dcm_clk_81mhz,
      SYS_Rst => fpga_reset,
      LMB_Rst => ilmb_OPB_Rst,
      M_ABus => ilmb_M_ABus,
      M_ReadStrobe => ilmb_M_ReadStrobe,
      M_WriteStrobe => net_gnd0,
      M_AddrStrobe => ilmb_M_AddrStrobe,
      M_DBus => net_gnd32,
      M_BE => net_gnd4,
      Sl_DBus => ilmb_Sl_DBus,
      Sl_Ready => ilmb_Sl_Ready(0 to 0),
      LMB_ABus => ilmb_LMB_ABus,
      LMB_ReadStrobe => ilmb_LMB_ReadStrobe,
      LMB_WriteStrobe => ilmb_LMB_WriteStrobe,
      LMB_AddrStrobe => ilmb_LMB_AddrStrobe,
      LMB_ReadDBus => ilmb_LMB_ReadDBus,
      LMB_WriteDBus => ilmb_LMB_WriteDBus,
      LMB_Ready => ilmb_LMB_Ready,
      LMB_BE => ilmb_LMB_BE
    );

  dlmb : dlmb_wrapper
    port map (
      LMB_Clk => dcm_clk_81mhz,
      SYS_Rst => fpga_reset,
      LMB_Rst => dlmb_OPB_Rst,
      M_ABus => dlmb_M_ABus,
      M_ReadStrobe => dlmb_M_ReadStrobe,
      M_WriteStrobe => dlmb_M_WriteStrobe,
      M_AddrStrobe => dlmb_M_AddrStrobe,
      M_DBus => dlmb_M_DBus,
      M_BE => dlmb_M_BE,
      Sl_DBus => dlmb_Sl_DBus,
      Sl_Ready => dlmb_Sl_Ready(0 to 0),
      LMB_ABus => dlmb_LMB_ABus,
      LMB_ReadStrobe => dlmb_LMB_ReadStrobe,
      LMB_WriteStrobe => dlmb_LMB_WriteStrobe,
      LMB_AddrStrobe => dlmb_LMB_AddrStrobe,
      LMB_ReadDBus => dlmb_LMB_ReadDBus,
      LMB_WriteDBus => dlmb_LMB_WriteDBus,
      LMB_Ready => dlmb_LMB_Ready,
      LMB_BE => dlmb_LMB_BE
    );

  dlmb_cntlr : dlmb_cntlr_wrapper
    port map (
      LMB_Clk => dcm_clk_81mhz,
      LMB_Rst => dlmb_OPB_Rst,
      LMB_ABus => dlmb_LMB_ABus,
      LMB_WriteDBus => dlmb_LMB_WriteDBus,
      LMB_AddrStrobe => dlmb_LMB_AddrStrobe,
      LMB_ReadStrobe => dlmb_LMB_ReadStrobe,
      LMB_WriteStrobe => dlmb_LMB_WriteStrobe,
      LMB_BE => dlmb_LMB_BE,
      Sl_DBus => dlmb_Sl_DBus,
      Sl_Ready => dlmb_Sl_Ready(0),
      BRAM_Rst_A => dlmb_port_BRAM_Rst,
      BRAM_Clk_A => dlmb_port_BRAM_Clk,
      BRAM_EN_A => dlmb_port_BRAM_EN,
      BRAM_WEN_A => dlmb_port_BRAM_WEN,
      BRAM_Addr_A => dlmb_port_BRAM_Addr,
      BRAM_Din_A => dlmb_port_BRAM_Din,
      BRAM_Dout_A => dlmb_port_BRAM_Dout
    );

  ilmb_cntlr : ilmb_cntlr_wrapper
    port map (
      LMB_Clk => dcm_clk_81mhz,
      LMB_Rst => ilmb_OPB_Rst,
      LMB_ABus => ilmb_LMB_ABus,
      LMB_WriteDBus => ilmb_LMB_WriteDBus,
      LMB_AddrStrobe => ilmb_LMB_AddrStrobe,
      LMB_ReadStrobe => ilmb_LMB_ReadStrobe,
      LMB_WriteStrobe => ilmb_LMB_WriteStrobe,
      LMB_BE => ilmb_LMB_BE,
      Sl_DBus => ilmb_Sl_DBus,
      Sl_Ready => ilmb_Sl_Ready(0),
      BRAM_Rst_A => ilmb_port_BRAM_Rst,
      BRAM_Clk_A => ilmb_port_BRAM_Clk,
      BRAM_EN_A => ilmb_port_BRAM_EN,
      BRAM_WEN_A => ilmb_port_BRAM_WEN,
      BRAM_Addr_A => ilmb_port_BRAM_Addr,
      BRAM_Din_A => ilmb_port_BRAM_Din,
      BRAM_Dout_A => ilmb_port_BRAM_Dout
    );

  lmb_bram : lmb_bram_wrapper
    port map (
      BRAM_Rst_A => ilmb_port_BRAM_Rst,
      BRAM_Clk_A => ilmb_port_BRAM_Clk,
      BRAM_EN_A => ilmb_port_BRAM_EN,
      BRAM_WEN_A => ilmb_port_BRAM_WEN,
      BRAM_Addr_A => ilmb_port_BRAM_Addr,
      BRAM_Din_A => ilmb_port_BRAM_Din,
      BRAM_Dout_A => ilmb_port_BRAM_Dout,
      BRAM_Rst_B => dlmb_port_BRAM_Rst,
      BRAM_Clk_B => dlmb_port_BRAM_Clk,
      BRAM_EN_B => dlmb_port_BRAM_EN,
      BRAM_WEN_B => dlmb_port_BRAM_WEN,
      BRAM_Addr_B => dlmb_port_BRAM_Addr,
      BRAM_Din_B => dlmb_port_BRAM_Din,
      BRAM_Dout_B => dlmb_port_BRAM_Dout
    );

  rs232 : rs232_wrapper
    port map (
      OPB_Clk => dcm_clk_81mhz,
      OPB_Rst => mb_opb_OPB_Rst,
      Interrupt => open,
      OPB_ABus => mb_opb_OPB_ABus,
      OPB_BE => mb_opb_OPB_BE,
      OPB_RNW => mb_opb_OPB_RNW,
      OPB_select => mb_opb_OPB_select,
      OPB_seqAddr => mb_opb_OPB_seqAddr,
      OPB_DBus => mb_opb_OPB_DBus,
      UART_DBus => mb_opb_Sl_DBus(32 to 63),
      UART_errAck => mb_opb_Sl_errAck(1),
      UART_retry => mb_opb_Sl_retry(1),
      UART_toutSup => mb_opb_Sl_toutSup(1),
      UART_xferAck => mb_opb_Sl_xferAck(1),
      RX => RS232_RX_IBUF,
      TX => RS232_TX_OBUF
    );

  opb_gpio_0 : opb_gpio_0_wrapper
    port map (
      OPB_ABus => mb_opb_OPB_ABus,
      OPB_BE => mb_opb_OPB_BE,
      OPB_Clk => dcm_clk_81mhz,
      OPB_DBus => mb_opb_OPB_DBus,
      OPB_RNW => mb_opb_OPB_RNW,
      OPB_Rst => mb_opb_OPB_Rst,
      OPB_select => mb_opb_OPB_select,
      OPB_seqAddr => mb_opb_OPB_seqAddr,
      Sln_DBus => mb_opb_Sl_DBus(64 to 95),
      Sln_errAck => mb_opb_Sl_errAck(2),
      Sln_retry => mb_opb_Sl_retry(2),
      Sln_toutSup => mb_opb_Sl_toutSup(2),
      Sln_xferAck => mb_opb_Sl_xferAck(2),
      IP2INTC_Irpt => open,
      GPIO_in => net_gnd4,
      GPIO_d_out => open,
      GPIO_t_out => open,
      GPIO2_in => net_gnd4,
      GPIO2_d_out => open,
      GPIO2_t_out => open,
      GPIO_IO_I => opb_gpio_0_GPIO_IO_I,
      GPIO_IO_O => opb_gpio_0_GPIO_IO_O,
      GPIO_IO_T => opb_gpio_0_GPIO_IO_T,
      GPIO2_IO_I => net_gnd4,
      GPIO2_IO_O => open,
      GPIO2_IO_T => open
    );

  opb_timer_0 : opb_timer_0_wrapper
    port map (
      OPB_Clk => dcm_clk_81mhz,
      OPB_Rst => mb_opb_OPB_Rst,
      OPB_ABus => mb_opb_OPB_ABus,
      OPB_BE => mb_opb_OPB_BE,
      OPB_DBus => mb_opb_OPB_DBus,
      OPB_RNW => mb_opb_OPB_RNW,
      OPB_select => mb_opb_OPB_select,
      OPB_seqAddr => mb_opb_OPB_seqAddr,
      TC_DBus => mb_opb_Sl_DBus(96 to 127),
      TC_errAck => mb_opb_Sl_errAck(3),
      TC_retry => mb_opb_Sl_retry(3),
      TC_toutSup => mb_opb_Sl_toutSup(3),
      TC_xferAck => mb_opb_Sl_xferAck(3),
      CaptureTrig0 => net_gnd0,
      CaptureTrig1 => net_gnd0,
      GenerateOut0 => open,
      GenerateOut1 => open,
      PWM0 => open,
      Interrupt => timer_out,
      Freeze => net_gnd0
    );

  opb_intc_0 : opb_intc_0_wrapper
    port map (
      OPB_Clk => dcm_clk_81mhz,
      Intr => pgassign1,
      OPB_Rst => mb_opb_OPB_Rst,
      OPB_ABus => mb_opb_OPB_ABus,
      OPB_BE => mb_opb_OPB_BE,
      OPB_RNW => mb_opb_OPB_RNW,
      OPB_select => mb_opb_OPB_select,
      OPB_seqAddr => mb_opb_OPB_seqAddr,
      OPB_DBus => mb_opb_OPB_DBus,
      IntC_DBus => mb_opb_Sl_DBus(128 to 159),
      IntC_errAck => mb_opb_Sl_errAck(4),
      IntC_retry => mb_opb_Sl_retry(4),
      IntC_toutSup => mb_opb_Sl_toutSup(4),
      IntC_xferAck => mb_opb_Sl_xferAck(4),
      Irq => INT_out
    );

  opb_ethernet_0 : opb_ethernet_0_wrapper
    port map (
      PHY_tx_clk => opb_ethernet_0_PHY_tx_clk_IBUF,
      PHY_rx_clk => opb_ethernet_0_PHY_rx_clk_IBUF,
      PHY_crs => opb_ethernet_0_PHY_crs_IBUF,
      PHY_dv => opb_ethernet_0_PHY_dv_IBUF,
      PHY_rx_data => opb_ethernet_0_PHY_rx_data_IBUF,
      PHY_col => opb_ethernet_0_PHY_col_IBUF,
      PHY_rx_er => opb_ethernet_0_PHY_rx_er_IBUF,
      OPB_ABus => mb_opb_OPB_ABus,
      OPB_DBus => mb_opb_OPB_DBus,
      OPB_errAck => net_gnd0,
      OPB_BE => mb_opb_OPB_BE,
      OPB_MGrant => net_gnd0,
      OPB_retry => net_gnd0,
      OPB_RNW => mb_opb_OPB_RNW,
      OPB_select => mb_opb_OPB_select,
      OPB_seqAddr => mb_opb_OPB_seqAddr,
      OPB_timeout => net_gnd0,
      OPB_xferAck => net_gnd0,
      Freeze => net_gnd0,
      OPB_Clk => dcm_clk_81mhz,
      OPB_Rst => mb_opb_OPB_Rst,
      PHY_tx_en => opb_ethernet_0_PHY_tx_en_OBUF,
      PHY_rx_en => open,
      PHY_tx_er => opb_ethernet_0_PHY_tx_er_OBUF,
      PHY_tx_data => opb_ethernet_0_PHY_tx_data_OBUF,
      PHY_rst_n => open,
      Sln_xferAck => mb_opb_Sl_xferAck(5),
      Sln_errAck => mb_opb_Sl_errAck(5),
      Sln_retry => mb_opb_Sl_retry(5),
      Sln_toutSup => mb_opb_Sl_toutSup(5),
      Sln_DBus => mb_opb_Sl_DBus(160 to 191),
      Mn_request => open,
      Mn_busLock => open,
      Mn_select => open,
      Mn_RNW => open,
      Mn_BE => open,
      Mn_seqAddr => open,
      Mn_ABus => open,
      emac_intrpts => open,
      IP2INTC_Irpt => emac_intr,
      PHY_Mii_clk_I => opb_ethernet_0_PHY_Mii_clk_I,
      PHY_Mii_clk_O => opb_ethernet_0_PHY_Mii_clk_O,
      PHY_Mii_clk_T => opb_ethernet_0_PHY_Mii_clk_T,
      PHY_Mii_data_I => opb_ethernet_0_PHY_Mii_data_I,
      PHY_Mii_data_O => opb_ethernet_0_PHY_Mii_data_O,
      PHY_Mii_data_T => opb_ethernet_0_PHY_Mii_data_T
    );

  dcm_sysclk : dcm_sysclk_wrapper
    port map (
      RST => dcm_reset,
      CLKIN => sys_clk_s,
      CLKFB => dcm_clk_27mhz,
      PSEN => net_gnd0,
      PSINCDEC => net_gnd0,
      PSCLK => net_gnd0,
      DSSEN => net_gnd0,
      CLK0 => dcm_clk_27mhz,
      CLK90 => open,
      CLK180 => open,
      CLK270 => open,
      CLKDV => open,
      CLK2X => open,
      CLK2X180 => open,
      CLKFX => dcm_clk_81mhz,
      CLKFX180 => open,
      STATUS => open,
      LOCKED => dcm_sysclk_locked,
      PSDONE => open
    );

  emc : emc_wrapper
    port map (
      OPB_Clk => dcm_clk_81mhz,
      OPB_Rst => mb_opb_OPB_Rst,
      OPB_ABus => mb_opb_OPB_ABus,
      OPB_DBus => mb_opb_OPB_DBus,
      Sln_DBus => mb_opb_Sl_DBus(192 to 223),
      OPB_select => mb_opb_OPB_select,
      OPB_RNW => mb_opb_OPB_RNW,
      OPB_seqAddr => mb_opb_OPB_seqAddr,
      OPB_BE => mb_opb_OPB_BE,
      Sln_xferAck => mb_opb_Sl_xferAck(6),
      Sln_errAck => mb_opb_Sl_errAck(6),
      Sln_toutSup => mb_opb_Sl_toutSup(6),
      Sln_retry => mb_opb_Sl_retry(6),
      Mem_A => emc_Mem_A,
      Mem_DQ_I => emc_Mem_DQ_I,
      Mem_DQ_O => emc_Mem_DQ_O,
      Mem_DQ_T => emc_Mem_DQ_T,
      Mem_CEN => emc_Mem_CEN,
      Mem_OEN => emc_Mem_OEN,
      Mem_WEN => emc_Mem_WEN,
      Mem_QWEN => open,
      Mem_BEN => emc_Mem_BEN,
      Mem_RPN => open,
      Mem_CE => open,
      Mem_ADV_LDN => emc_Mem_ADV_LDN,
      Mem_LBON => open,
      Mem_CKEN => emc_Mem_CKEN,
      Mem_RNW => open
    );

  dcm_memclk : dcm_memclk_wrapper
    port map (
      RST => dcm_reset,
      CLKIN => dcm_clk_81mhz,
      CLKFB => mem_clk_fbin,
      PSEN => net_gnd0,
      PSINCDEC => net_gnd0,
      PSCLK => net_gnd0,
      DSSEN => net_gnd0,
      CLK0 => mem_clk_fbout,
      CLK90 => open,
      CLK180 => open,
      CLK270 => open,
      CLKDV => open,
      CLK2X => open,
      CLK2X180 => open,
      CLKFX => open,
      CLKFX180 => open,
      STATUS => open,
      LOCKED => dcm_memclk_locked,
      PSDONE => open
    );

  zbt_access_ctrl : zbt_access_ctrl_wrapper
    port map (
      Mem_CLK => mem_clk_fbout,
      emc_Mem_A => emc_Mem_A,
      emc_Mem_DQ_I => emc_Mem_DQ_O,
      emc_Mem_DQ_O => emc_Mem_DQ_I,
      emc_Mem_DQ_T => emc_Mem_DQ_T,
      emc_Mem_CEN => emc_Mem_CEN,
      emc_Mem_OEN => emc_Mem_OEN,
      emc_Mem_WEN => emc_Mem_WEN,
      emc_Mem_BEN => emc_Mem_BEN,
      emc_Mem_ADV_LDN => emc_Mem_ADV_LDN,
      emc_Mem_CKEN => emc_Mem_CKEN,
      bank0_Mem_CLK => memory_bank0_clk_OBUF,
      bank0_Mem_A => memory_bank0_addr_p_OBUF(0 to 18),
      bank0_Mem_CEN => memory_bank0_cen_n_OBUF,
      bank0_Mem_OEN => memory_bank0_oen_n_OBUF,
      bank0_Mem_WEN => memory_bank0_wen_n_OBUF,
      bank0_Mem_BEN => memory_bank0_wen_OBUF,
      bank0_Mem_ADV_LDN => memory_bank0_adv_ld_n_OBUF,
      bank0_Mem_CKEN => memory_bank0_clken_n_OBUF,
      bank1_Mem_CLK => memory_bank1_clk_OBUF,
      bank1_Mem_A => memory_bank1_addr_p_OBUF(0 to 18),
      bank1_Mem_CEN => memory_bank1_cen_n_OBUF,
      bank1_Mem_OEN => memory_bank1_oen_n_OBUF,
      bank1_Mem_WEN => memory_bank1_wen_n_OBUF,
      bank1_Mem_BEN => memory_bank1_wen_OBUF,
      bank1_Mem_ADV_LDN => memory_bank1_adv_ld_n_OBUF,
      bank1_Mem_CKEN => memory_bank1_clken_n_OBUF,
      bank2_Mem_CLK => memory_bank2_clk_OBUF,
      bank2_Mem_A => memory_bank2_addr_p_OBUF(0 to 18),
      bank2_Mem_CEN => memory_bank2_cen_n_OBUF,
      bank2_Mem_OEN => memory_bank2_oen_n_OBUF,
      bank2_Mem_WEN => memory_bank2_wen_n_OBUF,
      bank2_Mem_BEN => memory_bank2_wen_OBUF,
      bank2_Mem_ADV_LDN => memory_bank2_adv_ld_n_OBUF,
      bank2_Mem_CKEN => memory_bank2_clken_n_OBUF,
      bank3_Mem_CLK => memory_bank3_clk_OBUF,
      bank3_Mem_A => memory_bank3_addr_p_OBUF(0 to 18),
      bank3_Mem_CEN => memory_bank3_cen_n_OBUF,
      bank3_Mem_OEN => memory_bank3_oen_n_OBUF,
      bank3_Mem_WEN => memory_bank3_wen_n_OBUF,
      bank3_Mem_BEN => memory_bank3_wen_OBUF,
      bank3_Mem_ADV_LDN => memory_bank3_adv_ld_n_OBUF,
      bank3_Mem_CKEN => memory_bank3_clken_n_OBUF,
      bank4_Mem_CLK => memory_bank4_clk_OBUF,
      bank4_Mem_A => memory_bank4_addr_p_OBUF(0 to 18),
      bank4_Mem_CEN => memory_bank4_cen_n_OBUF,
      bank4_Mem_OEN => memory_bank4_oen_n_OBUF,
      bank4_Mem_WEN => memory_bank4_wen_n_OBUF,
      bank4_Mem_BEN => memory_bank4_wen_OBUF,
      bank4_Mem_ADV_LDN => memory_bank4_adv_ld_n_OBUF,
      bank4_Mem_CKEN => memory_bank4_clken_n_OBUF,
      bank0_Mem_DQ_I => memory_bank0_data_I,
      bank0_Mem_DQ_O => memory_bank0_data_O,
      bank0_Mem_DQ_T => memory_bank0_data_T,
      bank1_Mem_DQ_I => memory_bank1_data_I,
      bank1_Mem_DQ_O => memory_bank1_data_O,
      bank1_Mem_DQ_T => memory_bank1_data_T,
      bank2_Mem_DQ_I => memory_bank2_data_I,
      bank2_Mem_DQ_O => memory_bank2_data_O,
      bank2_Mem_DQ_T => memory_bank2_data_T,
      bank3_Mem_DQ_I => memory_bank3_data_I,
      bank3_Mem_DQ_O => memory_bank3_data_O,
      bank3_Mem_DQ_T => memory_bank3_data_T,
      bank4_Mem_DQ_I => memory_bank4_data_I,
      bank4_Mem_DQ_O => memory_bank4_data_O,
      bank4_Mem_DQ_T => memory_bank4_data_T
    );

  clk_aligner : clk_aligner_wrapper
    port map (
      external_clk => sys_clk_s,
      extend_dcm_reset => net_gnd0,
      dcm0_locked => dcm_sysclk_locked,
      dcm1_locked => dcm_memclk_locked,
      fpga_reset => fpga_reset,
      dcm_reset => dcm_reset
    );

  obuf_0 : OBUF
    port map (
      I => RS232_TX_OBUF,
      O => RS232_TX
    );

  ibuf_1 : IBUF
    port map (
      I => RS232_RX,
      O => RS232_RX_IBUF
    );

  iobuf_2 : IOBUF
    port map (
      I => opb_gpio_0_GPIO_IO_O(0),
      IO => opb_gpio_0_GPIO_IO(0),
      O => opb_gpio_0_GPIO_IO_I(0),
      T => opb_gpio_0_GPIO_IO_T(0)
    );

  iobuf_3 : IOBUF
    port map (
      I => opb_gpio_0_GPIO_IO_O(1),
      IO => opb_gpio_0_GPIO_IO(1),
      O => opb_gpio_0_GPIO_IO_I(1),
      T => opb_gpio_0_GPIO_IO_T(1)
    );

  iobuf_4 : IOBUF
    port map (
      I => opb_gpio_0_GPIO_IO_O(2),
      IO => opb_gpio_0_GPIO_IO(2),
      O => opb_gpio_0_GPIO_IO_I(2),
      T => opb_gpio_0_GPIO_IO_T(2)
    );

  iobuf_5 : IOBUF
    port map (
      I => opb_gpio_0_GPIO_IO_O(3),
      IO => opb_gpio_0_GPIO_IO(3),
      O => opb_gpio_0_GPIO_IO_I(3),
      T => opb_gpio_0_GPIO_IO_T(3)
    );

  obuf_6 : OBUF
    port map (
      I => opb_ethernet_0_PHY_tx_data_OBUF(3),
      O => opb_ethernet_0_PHY_tx_data(3)
    );

  obuf_7 : OBUF
    port map (
      I => opb_ethernet_0_PHY_tx_data_OBUF(2),
      O => opb_ethernet_0_PHY_tx_data(2)
    );

  obuf_8 : OBUF
    port map (
      I => opb_ethernet_0_PHY_tx_data_OBUF(1),
      O => opb_ethernet_0_PHY_tx_data(1)
    );

  obuf_9 : OBUF
    port map (
      I => opb_ethernet_0_PHY_tx_data_OBUF(0),
      O => opb_ethernet_0_PHY_tx_data(0)
    );

  ibuf_10 : IBUF
    port map (
      I => opb_ethernet_0_PHY_col,
      O => opb_ethernet_0_PHY_col_IBUF
    );

  ibuf_11 : IBUF
    port map (
      I => opb_ethernet_0_PHY_crs,
      O => opb_ethernet_0_PHY_crs_IBUF
    );

  ibuf_12 : IBUF
    port map (
      I => opb_ethernet_0_PHY_tx_clk,
      O => opb_ethernet_0_PHY_tx_clk_IBUF
    );

  obuf_13 : OBUF
    port map (
      I => opb_ethernet_0_PHY_tx_en_OBUF,
      O => opb_ethernet_0_PHY_tx_en
    );

  ibuf_14 : IBUF
    port map (
      I => opb_ethernet_0_PHY_rx_er,
      O => opb_ethernet_0_PHY_rx_er_IBUF
    );

  ibuf_15 : IBUF
    port map (
      I => opb_ethernet_0_PHY_rx_data(3),
      O => opb_ethernet_0_PHY_rx_data_IBUF(3)
    );

  ibuf_16 : IBUF
    port map (
      I => opb_ethernet_0_PHY_rx_data(2),
      O => opb_ethernet_0_PHY_rx_data_IBUF(2)
    );

  ibuf_17 : IBUF
    port map (
      I => opb_ethernet_0_PHY_rx_data(1),
      O => opb_ethernet_0_PHY_rx_data_IBUF(1)
    );

  ibuf_18 : IBUF
    port map (
      I => opb_ethernet_0_PHY_rx_data(0),
      O => opb_ethernet_0_PHY_rx_data_IBUF(0)
    );

  ibuf_19 : IBUF
    port map (
      I => opb_ethernet_0_PHY_rx_clk,
      O => opb_ethernet_0_PHY_rx_clk_IBUF
    );

  ibuf_20 : IBUF
    port map (
      I => opb_ethernet_0_PHY_dv,
      O => opb_ethernet_0_PHY_dv_IBUF
    );

  iobuf_21 : IOBUF
    port map (
      I => opb_ethernet_0_PHY_Mii_clk_O,
      IO => opb_ethernet_0_PHY_Mii_clk,
      O => opb_ethernet_0_PHY_Mii_clk_I,
      T => opb_ethernet_0_PHY_Mii_clk_T
    );

  iobuf_22 : IOBUF
    port map (
      I => opb_ethernet_0_PHY_Mii_data_O,
      IO => opb_ethernet_0_PHY_Mii_data,
      O => opb_ethernet_0_PHY_Mii_data_I,
      T => opb_ethernet_0_PHY_Mii_data_T
    );

  obuf_23 : OBUF
    port map (
      I => opb_ethernet_0_PHY_tx_er_OBUF,
      O => opb_ethernet_0_PHY_tx_er
    );

  obuf_24 : OBUF
    port map (
      I => memory_bank2_cen_n_OBUF,
      O => memory_bank2_cen_n
    );

  obuf_25 : OBUF
    port map (
      I => memory_bank2_clk_OBUF,
      O => memory_bank2_clk
    );

  obuf_26 : OBUF
    port map (
      I => memory_bank2_clken_n_OBUF,
      O => memory_bank2_clken_n
    );

  iobuf_27 : IOBUF
    port map (
      I => memory_bank2_data_O(0),
      IO => memory_bank2_data(0),
      O => memory_bank2_data_I(0),
      T => memory_bank2_data_T(0)
    );

  iobuf_28 : IOBUF
    port map (
      I => memory_bank2_data_O(1),
      IO => memory_bank2_data(1),
      O => memory_bank2_data_I(1),
      T => memory_bank2_data_T(1)
    );

  iobuf_29 : IOBUF
    port map (
      I => memory_bank2_data_O(2),
      IO => memory_bank2_data(2),
      O => memory_bank2_data_I(2),
      T => memory_bank2_data_T(2)
    );

  iobuf_30 : IOBUF
    port map (
      I => memory_bank2_data_O(3),
      IO => memory_bank2_data(3),
      O => memory_bank2_data_I(3),
      T => memory_bank2_data_T(3)
    );

  iobuf_31 : IOBUF
    port map (
      I => memory_bank2_data_O(4),
      IO => memory_bank2_data(4),
      O => memory_bank2_data_I(4),
      T => memory_bank2_data_T(4)
    );

  iobuf_32 : IOBUF
    port map (
      I => memory_bank2_data_O(5),
      IO => memory_bank2_data(5),
      O => memory_bank2_data_I(5),
      T => memory_bank2_data_T(5)
    );

  iobuf_33 : IOBUF
    port map (
      I => memory_bank2_data_O(6),
      IO => memory_bank2_data(6),
      O => memory_bank2_data_I(6),
      T => memory_bank2_data_T(6)
    );

  iobuf_34 : IOBUF
    port map (
      I => memory_bank2_data_O(7),
      IO => memory_bank2_data(7),
      O => memory_bank2_data_I(7),
      T => memory_bank2_data_T(7)
    );

  iobuf_35 : IOBUF
    port map (
      I => memory_bank2_data_O(8),
      IO => memory_bank2_data(8),
      O => memory_bank2_data_I(8),
      T => memory_bank2_data_T(8)
    );

  iobuf_36 : IOBUF
    port map (
      I => memory_bank2_data_O(9),
      IO => memory_bank2_data(9),
      O => memory_bank2_data_I(9),
      T => memory_bank2_data_T(9)
    );

  iobuf_37 : IOBUF
    port map (
      I => memory_bank2_data_O(10),
      IO => memory_bank2_data(10),
      O => memory_bank2_data_I(10),
      T => memory_bank2_data_T(10)
    );

  iobuf_38 : IOBUF
    port map (
      I => memory_bank2_data_O(11),
      IO => memory_bank2_data(11),
      O => memory_bank2_data_I(11),
      T => memory_bank2_data_T(11)
    );

  iobuf_39 : IOBUF
    port map (
      I => memory_bank2_data_O(12),
      IO => memory_bank2_data(12),
      O => memory_bank2_data_I(12),
      T => memory_bank2_data_T(12)
    );

  iobuf_40 : IOBUF
    port map (
      I => memory_bank2_data_O(13),
      IO => memory_bank2_data(13),
      O => memory_bank2_data_I(13),
      T => memory_bank2_data_T(13)
    );

  iobuf_41 : IOBUF
    port map (
      I => memory_bank2_data_O(14),
      IO => memory_bank2_data(14),
      O => memory_bank2_data_I(14),
      T => memory_bank2_data_T(14)
    );

  iobuf_42 : IOBUF
    port map (
      I => memory_bank2_data_O(15),
      IO => memory_bank2_data(15),
      O => memory_bank2_data_I(15),
      T => memory_bank2_data_T(15)
    );

  iobuf_43 : IOBUF
    port map (
      I => memory_bank2_data_O(16),
      IO => memory_bank2_data(16),
      O => memory_bank2_data_I(16),
      T => memory_bank2_data_T(16)
    );

  iobuf_44 : IOBUF
    port map (
      I => memory_bank2_data_O(17),
      IO => memory_bank2_data(17),
      O => memory_bank2_data_I(17),
      T => memory_bank2_data_T(17)
    );

  iobuf_45 : IOBUF
    port map (
      I => memory_bank2_data_O(18),
      IO => memory_bank2_data(18),
      O => memory_bank2_data_I(18),
      T => memory_bank2_data_T(18)
    );

  iobuf_46 : IOBUF
    port map (
      I => memory_bank2_data_O(19),
      IO => memory_bank2_data(19),
      O => memory_bank2_data_I(19),
      T => memory_bank2_data_T(19)
    );

  iobuf_47 : IOBUF
    port map (
      I => memory_bank2_data_O(20),
      IO => memory_bank2_data(20),
      O => memory_bank2_data_I(20),
      T => memory_bank2_data_T(20)
    );

  iobuf_48 : IOBUF
    port map (
      I => memory_bank2_data_O(21),
      IO => memory_bank2_data(21),
      O => memory_bank2_data_I(21),
      T => memory_bank2_data_T(21)
    );

  iobuf_49 : IOBUF
    port map (
      I => memory_bank2_data_O(22),
      IO => memory_bank2_data(22),
      O => memory_bank2_data_I(22),
      T => memory_bank2_data_T(22)
    );

  iobuf_50 : IOBUF
    port map (
      I => memory_bank2_data_O(23),
      IO => memory_bank2_data(23),
      O => memory_bank2_data_I(23),
      T => memory_bank2_data_T(23)
    );

  iobuf_51 : IOBUF
    port map (
      I => memory_bank2_data_O(24),
      IO => memory_bank2_data(24),
      O => memory_bank2_data_I(24),
      T => memory_bank2_data_T(24)
    );

  iobuf_52 : IOBUF
    port map (
      I => memory_bank2_data_O(25),
      IO => memory_bank2_data(25),
      O => memory_bank2_data_I(25),
      T => memory_bank2_data_T(25)
    );

  iobuf_53 : IOBUF
    port map (
      I => memory_bank2_data_O(26),
      IO => memory_bank2_data(26),
      O => memory_bank2_data_I(26),
      T => memory_bank2_data_T(26)
    );

  iobuf_54 : IOBUF
    port map (
      I => memory_bank2_data_O(27),
      IO => memory_bank2_data(27),
      O => memory_bank2_data_I(27),
      T => memory_bank2_data_T(27)
    );

  iobuf_55 : IOBUF
    port map (
      I => memory_bank2_data_O(28),
      IO => memory_bank2_data(28),
      O => memory_bank2_data_I(28),
      T => memory_bank2_data_T(28)
    );

  iobuf_56 : IOBUF
    port map (
      I => memory_bank2_data_O(29),
      IO => memory_bank2_data(29),
      O => memory_bank2_data_I(29),
      T => memory_bank2_data_T(29)
    );

  iobuf_57 : IOBUF
    port map (
      I => memory_bank2_data_O(30),
      IO => memory_bank2_data(30),
      O => memory_bank2_data_I(30),
      T => memory_bank2_data_T(30)
    );

  iobuf_58 : IOBUF
    port map (
      I => memory_bank2_data_O(31),
      IO => memory_bank2_data(31),
      O => memory_bank2_data_I(31),
      T => memory_bank2_data_T(31)
    );

  obuf_59 : OBUF
    port map (
      I => memory_bank2_oen_n_OBUF,
      O => memory_bank2_oen_n
    );

  obuf_60 : OBUF
    port map (
      I => memory_bank2_wen_OBUF(1),
      O => memory_bank2_wen(1)
    );

  obuf_61 : OBUF
    port map (
      I => memory_bank2_wen_OBUF(2),
      O => memory_bank2_wen(2)
    );

  obuf_62 : OBUF
    port map (
      I => memory_bank2_wen_OBUF(3),
      O => memory_bank2_wen(3)
    );

  obuf_63 : OBUF
    port map (
      I => memory_bank2_wen_OBUF(4),
      O => memory_bank2_wen(4)
    );

  obuf_64 : OBUF
    port map (
      I => memory_bank2_wen_n_OBUF,
      O => memory_bank2_wen_n
    );

  obuf_65 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(0),
      O => memory_bank3_addr_p(0)
    );

  obuf_66 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(1),
      O => memory_bank3_addr_p(1)
    );

  obuf_67 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(2),
      O => memory_bank3_addr_p(2)
    );

  obuf_68 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(3),
      O => memory_bank3_addr_p(3)
    );

  obuf_69 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(4),
      O => memory_bank3_addr_p(4)
    );

  obuf_70 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(5),
      O => memory_bank3_addr_p(5)
    );

  obuf_71 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(6),
      O => memory_bank3_addr_p(6)
    );

  obuf_72 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(7),
      O => memory_bank3_addr_p(7)
    );

  obuf_73 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(8),
      O => memory_bank3_addr_p(8)
    );

  obuf_74 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(9),
      O => memory_bank3_addr_p(9)
    );

  obuf_75 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(10),
      O => memory_bank3_addr_p(10)
    );

  obuf_76 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(11),
      O => memory_bank3_addr_p(11)
    );

  obuf_77 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(12),
      O => memory_bank3_addr_p(12)
    );

  obuf_78 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(13),
      O => memory_bank3_addr_p(13)
    );

  obuf_79 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(14),
      O => memory_bank3_addr_p(14)
    );

  obuf_80 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(15),
      O => memory_bank3_addr_p(15)
    );

  obuf_81 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(16),
      O => memory_bank3_addr_p(16)
    );

  obuf_82 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(17),
      O => memory_bank3_addr_p(17)
    );

  obuf_83 : OBUF
    port map (
      I => memory_bank3_addr_p_OBUF(18),
      O => memory_bank3_addr_p(18)
    );

  obuf_84 : OBUF
    port map (
      I => memory_bank3_adv_ld_n_OBUF,
      O => memory_bank3_adv_ld_n
    );

  obuf_85 : OBUF
    port map (
      I => memory_bank3_cen_n_OBUF,
      O => memory_bank3_cen_n
    );

  obuf_86 : OBUF
    port map (
      I => memory_bank3_clk_OBUF,
      O => memory_bank3_clk
    );

  obuf_87 : OBUF
    port map (
      I => memory_bank3_clken_n_OBUF,
      O => memory_bank3_clken_n
    );

  iobuf_88 : IOBUF
    port map (
      I => memory_bank3_data_O(0),
      IO => memory_bank3_data(0),
      O => memory_bank3_data_I(0),
      T => memory_bank3_data_T(0)
    );

  iobuf_89 : IOBUF
    port map (
      I => memory_bank3_data_O(1),
      IO => memory_bank3_data(1),
      O => memory_bank3_data_I(1),
      T => memory_bank3_data_T(1)
    );

  iobuf_90 : IOBUF
    port map (
      I => memory_bank3_data_O(2),
      IO => memory_bank3_data(2),
      O => memory_bank3_data_I(2),
      T => memory_bank3_data_T(2)
    );

  iobuf_91 : IOBUF
    port map (
      I => memory_bank3_data_O(3),
      IO => memory_bank3_data(3),
      O => memory_bank3_data_I(3),
      T => memory_bank3_data_T(3)
    );

  iobuf_92 : IOBUF
    port map (
      I => memory_bank3_data_O(4),
      IO => memory_bank3_data(4),
      O => memory_bank3_data_I(4),
      T => memory_bank3_data_T(4)
    );

  iobuf_93 : IOBUF
    port map (
      I => memory_bank3_data_O(5),
      IO => memory_bank3_data(5),
      O => memory_bank3_data_I(5),
      T => memory_bank3_data_T(5)
    );

  iobuf_94 : IOBUF
    port map (
      I => memory_bank3_data_O(6),
      IO => memory_bank3_data(6),
      O => memory_bank3_data_I(6),
      T => memory_bank3_data_T(6)
    );

  iobuf_95 : IOBUF
    port map (
      I => memory_bank3_data_O(7),
      IO => memory_bank3_data(7),
      O => memory_bank3_data_I(7),
      T => memory_bank3_data_T(7)
    );

  iobuf_96 : IOBUF
    port map (
      I => memory_bank3_data_O(8),
      IO => memory_bank3_data(8),
      O => memory_bank3_data_I(8),
      T => memory_bank3_data_T(8)
    );

  iobuf_97 : IOBUF
    port map (
      I => memory_bank3_data_O(9),
      IO => memory_bank3_data(9),
      O => memory_bank3_data_I(9),
      T => memory_bank3_data_T(9)
    );

  iobuf_98 : IOBUF
    port map (
      I => memory_bank3_data_O(10),
      IO => memory_bank3_data(10),
      O => memory_bank3_data_I(10),
      T => memory_bank3_data_T(10)
    );

  iobuf_99 : IOBUF
    port map (
      I => memory_bank3_data_O(11),
      IO => memory_bank3_data(11),
      O => memory_bank3_data_I(11),
      T => memory_bank3_data_T(11)
    );

  iobuf_100 : IOBUF
    port map (
      I => memory_bank3_data_O(12),
      IO => memory_bank3_data(12),
      O => memory_bank3_data_I(12),
      T => memory_bank3_data_T(12)
    );

  iobuf_101 : IOBUF
    port map (
      I => memory_bank3_data_O(13),
      IO => memory_bank3_data(13),
      O => memory_bank3_data_I(13),
      T => memory_bank3_data_T(13)
    );

  iobuf_102 : IOBUF
    port map (
      I => memory_bank3_data_O(14),
      IO => memory_bank3_data(14),
      O => memory_bank3_data_I(14),
      T => memory_bank3_data_T(14)
    );

  iobuf_103 : IOBUF
    port map (
      I => memory_bank3_data_O(15),
      IO => memory_bank3_data(15),
      O => memory_bank3_data_I(15),
      T => memory_bank3_data_T(15)
    );

  iobuf_104 : IOBUF
    port map (
      I => memory_bank3_data_O(16),
      IO => memory_bank3_data(16),
      O => memory_bank3_data_I(16),
      T => memory_bank3_data_T(16)
    );

  iobuf_105 : IOBUF
    port map (
      I => memory_bank3_data_O(17),
      IO => memory_bank3_data(17),
      O => memory_bank3_data_I(17),
      T => memory_bank3_data_T(17)
    );

  iobuf_106 : IOBUF
    port map (
      I => memory_bank3_data_O(18),
      IO => memory_bank3_data(18),
      O => memory_bank3_data_I(18),
      T => memory_bank3_data_T(18)
    );

  iobuf_107 : IOBUF
    port map (
      I => memory_bank3_data_O(19),
      IO => memory_bank3_data(19),
      O => memory_bank3_data_I(19),
      T => memory_bank3_data_T(19)
    );

  iobuf_108 : IOBUF
    port map (
      I => memory_bank3_data_O(20),
      IO => memory_bank3_data(20),
      O => memory_bank3_data_I(20),
      T => memory_bank3_data_T(20)
    );

  iobuf_109 : IOBUF
    port map (
      I => memory_bank3_data_O(21),
      IO => memory_bank3_data(21),
      O => memory_bank3_data_I(21),
      T => memory_bank3_data_T(21)
    );

  iobuf_110 : IOBUF
    port map (
      I => memory_bank3_data_O(22),
      IO => memory_bank3_data(22),
      O => memory_bank3_data_I(22),
      T => memory_bank3_data_T(22)
    );

  iobuf_111 : IOBUF
    port map (
      I => memory_bank3_data_O(23),
      IO => memory_bank3_data(23),
      O => memory_bank3_data_I(23),
      T => memory_bank3_data_T(23)
    );

  iobuf_112 : IOBUF
    port map (
      I => memory_bank3_data_O(24),
      IO => memory_bank3_data(24),
      O => memory_bank3_data_I(24),
      T => memory_bank3_data_T(24)
    );

  iobuf_113 : IOBUF
    port map (
      I => memory_bank3_data_O(25),
      IO => memory_bank3_data(25),
      O => memory_bank3_data_I(25),
      T => memory_bank3_data_T(25)
    );

  iobuf_114 : IOBUF
    port map (
      I => memory_bank3_data_O(26),
      IO => memory_bank3_data(26),
      O => memory_bank3_data_I(26),
      T => memory_bank3_data_T(26)
    );

  iobuf_115 : IOBUF
    port map (
      I => memory_bank3_data_O(27),
      IO => memory_bank3_data(27),
      O => memory_bank3_data_I(27),
      T => memory_bank3_data_T(27)
    );

  iobuf_116 : IOBUF
    port map (
      I => memory_bank3_data_O(28),
      IO => memory_bank3_data(28),
      O => memory_bank3_data_I(28),
      T => memory_bank3_data_T(28)
    );

  iobuf_117 : IOBUF
    port map (
      I => memory_bank3_data_O(29),
      IO => memory_bank3_data(29),
      O => memory_bank3_data_I(29),
      T => memory_bank3_data_T(29)
    );

  iobuf_118 : IOBUF
    port map (
      I => memory_bank3_data_O(30),
      IO => memory_bank3_data(30),
      O => memory_bank3_data_I(30),
      T => memory_bank3_data_T(30)
    );

  iobuf_119 : IOBUF
    port map (
      I => memory_bank3_data_O(31),
      IO => memory_bank3_data(31),
      O => memory_bank3_data_I(31),
      T => memory_bank3_data_T(31)
    );

  obuf_120 : OBUF
    port map (
      I => memory_bank3_oen_n_OBUF,
      O => memory_bank3_oen_n
    );

  obuf_121 : OBUF
    port map (
      I => memory_bank3_wen_OBUF(1),
      O => memory_bank3_wen(1)
    );

  obuf_122 : OBUF
    port map (
      I => memory_bank3_wen_OBUF(2),
      O => memory_bank3_wen(2)
    );

  obuf_123 : OBUF
    port map (
      I => memory_bank3_wen_OBUF(3),
      O => memory_bank3_wen(3)
    );

  obuf_124 : OBUF
    port map (
      I => memory_bank3_wen_OBUF(4),
      O => memory_bank3_wen(4)
    );

  obuf_125 : OBUF
    port map (
      I => memory_bank3_wen_n_OBUF,
      O => memory_bank3_wen_n
    );

  obuf_126 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(0),
      O => memory_bank4_addr_p(0)
    );

  obuf_127 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(1),
      O => memory_bank4_addr_p(1)
    );

  obuf_128 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(2),
      O => memory_bank4_addr_p(2)
    );

  obuf_129 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(3),
      O => memory_bank4_addr_p(3)
    );

  obuf_130 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(4),
      O => memory_bank4_addr_p(4)
    );

  obuf_131 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(5),
      O => memory_bank4_addr_p(5)
    );

  obuf_132 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(6),
      O => memory_bank4_addr_p(6)
    );

  obuf_133 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(7),
      O => memory_bank4_addr_p(7)
    );

  obuf_134 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(8),
      O => memory_bank4_addr_p(8)
    );

  obuf_135 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(9),
      O => memory_bank4_addr_p(9)
    );

  obuf_136 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(10),
      O => memory_bank4_addr_p(10)
    );

  obuf_137 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(11),
      O => memory_bank4_addr_p(11)
    );

  obuf_138 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(12),
      O => memory_bank4_addr_p(12)
    );

  obuf_139 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(13),
      O => memory_bank4_addr_p(13)
    );

  obuf_140 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(14),
      O => memory_bank4_addr_p(14)
    );

  obuf_141 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(15),
      O => memory_bank4_addr_p(15)
    );

  obuf_142 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(16),
      O => memory_bank4_addr_p(16)
    );

  obuf_143 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(17),
      O => memory_bank4_addr_p(17)
    );

  obuf_144 : OBUF
    port map (
      I => memory_bank4_addr_p_OBUF(18),
      O => memory_bank4_addr_p(18)
    );

  obuf_145 : OBUF
    port map (
      I => memory_bank4_adv_ld_n_OBUF,
      O => memory_bank4_adv_ld_n
    );

  obuf_146 : OBUF
    port map (
      I => memory_bank4_cen_n_OBUF,
      O => memory_bank4_cen_n
    );

  obuf_147 : OBUF
    port map (
      I => memory_bank4_clk_OBUF,
      O => memory_bank4_clk
    );

  obuf_148 : OBUF
    port map (
      I => memory_bank4_clken_n_OBUF,
      O => memory_bank4_clken_n
    );

  iobuf_149 : IOBUF
    port map (
      I => memory_bank4_data_O(0),
      IO => memory_bank4_data(0),
      O => memory_bank4_data_I(0),
      T => memory_bank4_data_T(0)
    );

  iobuf_150 : IOBUF
    port map (
      I => memory_bank4_data_O(1),
      IO => memory_bank4_data(1),
      O => memory_bank4_data_I(1),
      T => memory_bank4_data_T(1)
    );

  iobuf_151 : IOBUF
    port map (
      I => memory_bank4_data_O(2),
      IO => memory_bank4_data(2),
      O => memory_bank4_data_I(2),
      T => memory_bank4_data_T(2)
    );

  iobuf_152 : IOBUF
    port map (
      I => memory_bank4_data_O(3),
      IO => memory_bank4_data(3),
      O => memory_bank4_data_I(3),
      T => memory_bank4_data_T(3)
    );

  iobuf_153 : IOBUF
    port map (
      I => memory_bank4_data_O(4),
      IO => memory_bank4_data(4),
      O => memory_bank4_data_I(4),
      T => memory_bank4_data_T(4)
    );

  iobuf_154 : IOBUF
    port map (
      I => memory_bank4_data_O(5),
      IO => memory_bank4_data(5),
      O => memory_bank4_data_I(5),
      T => memory_bank4_data_T(5)
    );

  iobuf_155 : IOBUF
    port map (
      I => memory_bank4_data_O(6),
      IO => memory_bank4_data(6),
      O => memory_bank4_data_I(6),
      T => memory_bank4_data_T(6)
    );

  iobuf_156 : IOBUF
    port map (
      I => memory_bank4_data_O(7),
      IO => memory_bank4_data(7),
      O => memory_bank4_data_I(7),
      T => memory_bank4_data_T(7)
    );

  iobuf_157 : IOBUF
    port map (
      I => memory_bank4_data_O(8),
      IO => memory_bank4_data(8),
      O => memory_bank4_data_I(8),
      T => memory_bank4_data_T(8)
    );

  iobuf_158 : IOBUF
    port map (
      I => memory_bank4_data_O(9),
      IO => memory_bank4_data(9),
      O => memory_bank4_data_I(9),
      T => memory_bank4_data_T(9)
    );

  iobuf_159 : IOBUF
    port map (
      I => memory_bank4_data_O(10),
      IO => memory_bank4_data(10),
      O => memory_bank4_data_I(10),
      T => memory_bank4_data_T(10)
    );

  iobuf_160 : IOBUF
    port map (
      I => memory_bank4_data_O(11),
      IO => memory_bank4_data(11),
      O => memory_bank4_data_I(11),
      T => memory_bank4_data_T(11)
    );

  iobuf_161 : IOBUF
    port map (
      I => memory_bank4_data_O(12),
      IO => memory_bank4_data(12),
      O => memory_bank4_data_I(12),
      T => memory_bank4_data_T(12)
    );

  iobuf_162 : IOBUF
    port map (
      I => memory_bank4_data_O(13),
      IO => memory_bank4_data(13),
      O => memory_bank4_data_I(13),
      T => memory_bank4_data_T(13)
    );

  iobuf_163 : IOBUF
    port map (
      I => memory_bank4_data_O(14),
      IO => memory_bank4_data(14),
      O => memory_bank4_data_I(14),
      T => memory_bank4_data_T(14)
    );

  iobuf_164 : IOBUF
    port map (
      I => memory_bank4_data_O(15),
      IO => memory_bank4_data(15),
      O => memory_bank4_data_I(15),
      T => memory_bank4_data_T(15)
    );

  iobuf_165 : IOBUF
    port map (
      I => memory_bank4_data_O(16),
      IO => memory_bank4_data(16),
      O => memory_bank4_data_I(16),
      T => memory_bank4_data_T(16)
    );

  iobuf_166 : IOBUF
    port map (
      I => memory_bank4_data_O(17),
      IO => memory_bank4_data(17),
      O => memory_bank4_data_I(17),
      T => memory_bank4_data_T(17)
    );

  iobuf_167 : IOBUF
    port map (
      I => memory_bank4_data_O(18),
      IO => memory_bank4_data(18),
      O => memory_bank4_data_I(18),
      T => memory_bank4_data_T(18)
    );

  iobuf_168 : IOBUF
    port map (
      I => memory_bank4_data_O(19),
      IO => memory_bank4_data(19),
      O => memory_bank4_data_I(19),
      T => memory_bank4_data_T(19)
    );

  iobuf_169 : IOBUF
    port map (
      I => memory_bank4_data_O(20),
      IO => memory_bank4_data(20),
      O => memory_bank4_data_I(20),
      T => memory_bank4_data_T(20)
    );

  iobuf_170 : IOBUF
    port map (
      I => memory_bank4_data_O(21),
      IO => memory_bank4_data(21),
      O => memory_bank4_data_I(21),
      T => memory_bank4_data_T(21)
    );

  iobuf_171 : IOBUF
    port map (
      I => memory_bank4_data_O(22),
      IO => memory_bank4_data(22),
      O => memory_bank4_data_I(22),
      T => memory_bank4_data_T(22)
    );

  iobuf_172 : IOBUF
    port map (
      I => memory_bank4_data_O(23),
      IO => memory_bank4_data(23),
      O => memory_bank4_data_I(23),
      T => memory_bank4_data_T(23)
    );

  iobuf_173 : IOBUF
    port map (
      I => memory_bank4_data_O(24),
      IO => memory_bank4_data(24),
      O => memory_bank4_data_I(24),
      T => memory_bank4_data_T(24)
    );

  iobuf_174 : IOBUF
    port map (
      I => memory_bank4_data_O(25),
      IO => memory_bank4_data(25),
      O => memory_bank4_data_I(25),
      T => memory_bank4_data_T(25)
    );

  iobuf_175 : IOBUF
    port map (
      I => memory_bank4_data_O(26),
      IO => memory_bank4_data(26),
      O => memory_bank4_data_I(26),
      T => memory_bank4_data_T(26)
    );

  iobuf_176 : IOBUF
    port map (
      I => memory_bank4_data_O(27),
      IO => memory_bank4_data(27),
      O => memory_bank4_data_I(27),
      T => memory_bank4_data_T(27)
    );

  iobuf_177 : IOBUF
    port map (
      I => memory_bank4_data_O(28),
      IO => memory_bank4_data(28),
      O => memory_bank4_data_I(28),
      T => memory_bank4_data_T(28)
    );

  iobuf_178 : IOBUF
    port map (
      I => memory_bank4_data_O(29),
      IO => memory_bank4_data(29),
      O => memory_bank4_data_I(29),
      T => memory_bank4_data_T(29)
    );

  iobuf_179 : IOBUF
    port map (
      I => memory_bank4_data_O(30),
      IO => memory_bank4_data(30),
      O => memory_bank4_data_I(30),
      T => memory_bank4_data_T(30)
    );

  iobuf_180 : IOBUF
    port map (
      I => memory_bank4_data_O(31),
      IO => memory_bank4_data(31),
      O => memory_bank4_data_I(31),
      T => memory_bank4_data_T(31)
    );

  obuf_181 : OBUF
    port map (
      I => memory_bank4_oen_n_OBUF,
      O => memory_bank4_oen_n
    );

  obuf_182 : OBUF
    port map (
      I => memory_bank4_wen_OBUF(1),
      O => memory_bank4_wen(1)
    );

  obuf_183 : OBUF
    port map (
      I => memory_bank4_wen_OBUF(2),
      O => memory_bank4_wen(2)
    );

  obuf_184 : OBUF
    port map (
      I => memory_bank4_wen_OBUF(3),
      O => memory_bank4_wen(3)
    );

  obuf_185 : OBUF
    port map (
      I => memory_bank4_wen_OBUF(4),
      O => memory_bank4_wen(4)
    );

  obuf_186 : OBUF
    port map (
      I => memory_bank4_wen_n_OBUF,
      O => memory_bank4_wen_n
    );

  obuf_187 : OBUF
    port map (
      I => memory_bank2_adv_ld_n_OBUF,
      O => memory_bank2_adv_ld_n
    );

  obuf_188 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(0),
      O => memory_bank2_addr_p(0)
    );

  obuf_189 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(1),
      O => memory_bank2_addr_p(1)
    );

  obuf_190 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(2),
      O => memory_bank2_addr_p(2)
    );

  obuf_191 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(3),
      O => memory_bank2_addr_p(3)
    );

  obuf_192 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(4),
      O => memory_bank2_addr_p(4)
    );

  obuf_193 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(5),
      O => memory_bank2_addr_p(5)
    );

  obuf_194 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(6),
      O => memory_bank2_addr_p(6)
    );

  obuf_195 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(7),
      O => memory_bank2_addr_p(7)
    );

  obuf_196 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(8),
      O => memory_bank2_addr_p(8)
    );

  obuf_197 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(9),
      O => memory_bank2_addr_p(9)
    );

  obuf_198 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(10),
      O => memory_bank2_addr_p(10)
    );

  obuf_199 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(11),
      O => memory_bank2_addr_p(11)
    );

  obuf_200 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(12),
      O => memory_bank2_addr_p(12)
    );

  obuf_201 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(13),
      O => memory_bank2_addr_p(13)
    );

  obuf_202 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(14),
      O => memory_bank2_addr_p(14)
    );

  obuf_203 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(15),
      O => memory_bank2_addr_p(15)
    );

  obuf_204 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(16),
      O => memory_bank2_addr_p(16)
    );

  obuf_205 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(17),
      O => memory_bank2_addr_p(17)
    );

  obuf_206 : OBUF
    port map (
      I => memory_bank2_addr_p_OBUF(18),
      O => memory_bank2_addr_p(18)
    );

  obuf_207 : OBUF
    port map (
      I => memory_bank1_wen_n_OBUF,
      O => memory_bank1_wen_n
    );

  obuf_208 : OBUF
    port map (
      I => memory_bank1_wen_OBUF(1),
      O => memory_bank1_wen(1)
    );

  obuf_209 : OBUF
    port map (
      I => memory_bank1_wen_OBUF(2),
      O => memory_bank1_wen(2)
    );

  obuf_210 : OBUF
    port map (
      I => memory_bank1_wen_OBUF(3),
      O => memory_bank1_wen(3)
    );

  obuf_211 : OBUF
    port map (
      I => memory_bank1_wen_OBUF(4),
      O => memory_bank1_wen(4)
    );

  obuf_212 : OBUF
    port map (
      I => memory_bank1_oen_n_OBUF,
      O => memory_bank1_oen_n
    );

  iobuf_213 : IOBUF
    port map (
      I => memory_bank1_data_O(0),
      IO => memory_bank1_data(0),
      O => memory_bank1_data_I(0),
      T => memory_bank1_data_T(0)
    );

  iobuf_214 : IOBUF
    port map (
      I => memory_bank1_data_O(1),
      IO => memory_bank1_data(1),
      O => memory_bank1_data_I(1),
      T => memory_bank1_data_T(1)
    );

  iobuf_215 : IOBUF
    port map (
      I => memory_bank1_data_O(2),
      IO => memory_bank1_data(2),
      O => memory_bank1_data_I(2),
      T => memory_bank1_data_T(2)
    );

  iobuf_216 : IOBUF
    port map (
      I => memory_bank1_data_O(3),
      IO => memory_bank1_data(3),
      O => memory_bank1_data_I(3),
      T => memory_bank1_data_T(3)
    );

  iobuf_217 : IOBUF
    port map (
      I => memory_bank1_data_O(4),
      IO => memory_bank1_data(4),
      O => memory_bank1_data_I(4),
      T => memory_bank1_data_T(4)
    );

  iobuf_218 : IOBUF
    port map (
      I => memory_bank1_data_O(5),
      IO => memory_bank1_data(5),
      O => memory_bank1_data_I(5),
      T => memory_bank1_data_T(5)
    );

  iobuf_219 : IOBUF
    port map (
      I => memory_bank1_data_O(6),
      IO => memory_bank1_data(6),
      O => memory_bank1_data_I(6),
      T => memory_bank1_data_T(6)
    );

  iobuf_220 : IOBUF
    port map (
      I => memory_bank1_data_O(7),
      IO => memory_bank1_data(7),
      O => memory_bank1_data_I(7),
      T => memory_bank1_data_T(7)
    );

  iobuf_221 : IOBUF
    port map (
      I => memory_bank1_data_O(8),
      IO => memory_bank1_data(8),
      O => memory_bank1_data_I(8),
      T => memory_bank1_data_T(8)
    );

  iobuf_222 : IOBUF
    port map (
      I => memory_bank1_data_O(9),
      IO => memory_bank1_data(9),
      O => memory_bank1_data_I(9),
      T => memory_bank1_data_T(9)
    );

  iobuf_223 : IOBUF
    port map (
      I => memory_bank1_data_O(10),
      IO => memory_bank1_data(10),
      O => memory_bank1_data_I(10),
      T => memory_bank1_data_T(10)
    );

  iobuf_224 : IOBUF
    port map (
      I => memory_bank1_data_O(11),
      IO => memory_bank1_data(11),
      O => memory_bank1_data_I(11),
      T => memory_bank1_data_T(11)
    );

  iobuf_225 : IOBUF
    port map (
      I => memory_bank1_data_O(12),
      IO => memory_bank1_data(12),
      O => memory_bank1_data_I(12),
      T => memory_bank1_data_T(12)
    );

  iobuf_226 : IOBUF
    port map (
      I => memory_bank1_data_O(13),
      IO => memory_bank1_data(13),
      O => memory_bank1_data_I(13),
      T => memory_bank1_data_T(13)
    );

  iobuf_227 : IOBUF
    port map (
      I => memory_bank1_data_O(14),
      IO => memory_bank1_data(14),
      O => memory_bank1_data_I(14),
      T => memory_bank1_data_T(14)
    );

  iobuf_228 : IOBUF
    port map (
      I => memory_bank1_data_O(15),
      IO => memory_bank1_data(15),
      O => memory_bank1_data_I(15),
      T => memory_bank1_data_T(15)
    );

  iobuf_229 : IOBUF
    port map (
      I => memory_bank1_data_O(16),
      IO => memory_bank1_data(16),
      O => memory_bank1_data_I(16),
      T => memory_bank1_data_T(16)
    );

  iobuf_230 : IOBUF
    port map (
      I => memory_bank1_data_O(17),
      IO => memory_bank1_data(17),
      O => memory_bank1_data_I(17),
      T => memory_bank1_data_T(17)
    );

  iobuf_231 : IOBUF
    port map (
      I => memory_bank1_data_O(18),
      IO => memory_bank1_data(18),
      O => memory_bank1_data_I(18),
      T => memory_bank1_data_T(18)
    );

  iobuf_232 : IOBUF
    port map (
      I => memory_bank1_data_O(19),
      IO => memory_bank1_data(19),
      O => memory_bank1_data_I(19),
      T => memory_bank1_data_T(19)
    );

  iobuf_233 : IOBUF
    port map (
      I => memory_bank1_data_O(20),
      IO => memory_bank1_data(20),
      O => memory_bank1_data_I(20),
      T => memory_bank1_data_T(20)
    );

  iobuf_234 : IOBUF
    port map (
      I => memory_bank1_data_O(21),
      IO => memory_bank1_data(21),
      O => memory_bank1_data_I(21),
      T => memory_bank1_data_T(21)
    );

  iobuf_235 : IOBUF
    port map (
      I => memory_bank1_data_O(22),
      IO => memory_bank1_data(22),
      O => memory_bank1_data_I(22),
      T => memory_bank1_data_T(22)
    );

  iobuf_236 : IOBUF
    port map (
      I => memory_bank1_data_O(23),
      IO => memory_bank1_data(23),
      O => memory_bank1_data_I(23),
      T => memory_bank1_data_T(23)
    );

  iobuf_237 : IOBUF
    port map (
      I => memory_bank1_data_O(24),
      IO => memory_bank1_data(24),
      O => memory_bank1_data_I(24),
      T => memory_bank1_data_T(24)
    );

  iobuf_238 : IOBUF
    port map (
      I => memory_bank1_data_O(25),
      IO => memory_bank1_data(25),
      O => memory_bank1_data_I(25),
      T => memory_bank1_data_T(25)
    );

  iobuf_239 : IOBUF
    port map (
      I => memory_bank1_data_O(26),
      IO => memory_bank1_data(26),
      O => memory_bank1_data_I(26),
      T => memory_bank1_data_T(26)
    );

  iobuf_240 : IOBUF
    port map (
      I => memory_bank1_data_O(27),
      IO => memory_bank1_data(27),
      O => memory_bank1_data_I(27),
      T => memory_bank1_data_T(27)
    );

  iobuf_241 : IOBUF
    port map (
      I => memory_bank1_data_O(28),
      IO => memory_bank1_data(28),
      O => memory_bank1_data_I(28),
      T => memory_bank1_data_T(28)
    );

  iobuf_242 : IOBUF
    port map (
      I => memory_bank1_data_O(29),
      IO => memory_bank1_data(29),
      O => memory_bank1_data_I(29),
      T => memory_bank1_data_T(29)
    );

  iobuf_243 : IOBUF
    port map (
      I => memory_bank1_data_O(30),
      IO => memory_bank1_data(30),
      O => memory_bank1_data_I(30),
      T => memory_bank1_data_T(30)
    );

  iobuf_244 : IOBUF
    port map (
      I => memory_bank1_data_O(31),
      IO => memory_bank1_data(31),
      O => memory_bank1_data_I(31),
      T => memory_bank1_data_T(31)
    );

  obuf_245 : OBUF
    port map (
      I => memory_bank1_clken_n_OBUF,
      O => memory_bank1_clken_n
    );

  obuf_246 : OBUF
    port map (
      I => memory_bank1_clk_OBUF,
      O => memory_bank1_clk
    );

  obuf_247 : OBUF
    port map (
      I => memory_bank1_cen_n_OBUF,
      O => memory_bank1_cen_n
    );

  obuf_248 : OBUF
    port map (
      I => memory_bank1_adv_ld_n_OBUF,
      O => memory_bank1_adv_ld_n
    );

  obuf_249 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(0),
      O => memory_bank1_addr_p(0)
    );

  obuf_250 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(1),
      O => memory_bank1_addr_p(1)
    );

  obuf_251 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(2),
      O => memory_bank1_addr_p(2)
    );

  obuf_252 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(3),
      O => memory_bank1_addr_p(3)
    );

  obuf_253 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(4),
      O => memory_bank1_addr_p(4)
    );

  obuf_254 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(5),
      O => memory_bank1_addr_p(5)
    );

  obuf_255 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(6),
      O => memory_bank1_addr_p(6)
    );

  obuf_256 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(7),
      O => memory_bank1_addr_p(7)
    );

  obuf_257 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(8),
      O => memory_bank1_addr_p(8)
    );

  obuf_258 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(9),
      O => memory_bank1_addr_p(9)
    );

  obuf_259 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(10),
      O => memory_bank1_addr_p(10)
    );

  obuf_260 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(11),
      O => memory_bank1_addr_p(11)
    );

  obuf_261 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(12),
      O => memory_bank1_addr_p(12)
    );

  obuf_262 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(13),
      O => memory_bank1_addr_p(13)
    );

  obuf_263 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(14),
      O => memory_bank1_addr_p(14)
    );

  obuf_264 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(15),
      O => memory_bank1_addr_p(15)
    );

  obuf_265 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(16),
      O => memory_bank1_addr_p(16)
    );

  obuf_266 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(17),
      O => memory_bank1_addr_p(17)
    );

  obuf_267 : OBUF
    port map (
      I => memory_bank1_addr_p_OBUF(18),
      O => memory_bank1_addr_p(18)
    );

  obuf_268 : OBUF
    port map (
      I => memory_bank0_wen_n_OBUF,
      O => memory_bank0_wen_n
    );

  obuf_269 : OBUF
    port map (
      I => memory_bank0_wen_OBUF(1),
      O => memory_bank0_wen(1)
    );

  obuf_270 : OBUF
    port map (
      I => memory_bank0_wen_OBUF(2),
      O => memory_bank0_wen(2)
    );

  obuf_271 : OBUF
    port map (
      I => memory_bank0_wen_OBUF(3),
      O => memory_bank0_wen(3)
    );

  obuf_272 : OBUF
    port map (
      I => memory_bank0_wen_OBUF(4),
      O => memory_bank0_wen(4)
    );

  obuf_273 : OBUF
    port map (
      I => memory_bank0_oen_n_OBUF,
      O => memory_bank0_oen_n
    );

  iobuf_274 : IOBUF
    port map (
      I => memory_bank0_data_O(0),
      IO => memory_bank0_data(0),
      O => memory_bank0_data_I(0),
      T => memory_bank0_data_T(0)
    );

  iobuf_275 : IOBUF
    port map (
      I => memory_bank0_data_O(1),
      IO => memory_bank0_data(1),
      O => memory_bank0_data_I(1),
      T => memory_bank0_data_T(1)
    );

  iobuf_276 : IOBUF
    port map (
      I => memory_bank0_data_O(2),
      IO => memory_bank0_data(2),
      O => memory_bank0_data_I(2),
      T => memory_bank0_data_T(2)
    );

  iobuf_277 : IOBUF
    port map (
      I => memory_bank0_data_O(3),
      IO => memory_bank0_data(3),
      O => memory_bank0_data_I(3),
      T => memory_bank0_data_T(3)
    );

  iobuf_278 : IOBUF
    port map (
      I => memory_bank0_data_O(4),
      IO => memory_bank0_data(4),
      O => memory_bank0_data_I(4),
      T => memory_bank0_data_T(4)
    );

  iobuf_279 : IOBUF
    port map (
      I => memory_bank0_data_O(5),
      IO => memory_bank0_data(5),
      O => memory_bank0_data_I(5),
      T => memory_bank0_data_T(5)
    );

  iobuf_280 : IOBUF
    port map (
      I => memory_bank0_data_O(6),
      IO => memory_bank0_data(6),
      O => memory_bank0_data_I(6),
      T => memory_bank0_data_T(6)
    );

  iobuf_281 : IOBUF
    port map (
      I => memory_bank0_data_O(7),
      IO => memory_bank0_data(7),
      O => memory_bank0_data_I(7),
      T => memory_bank0_data_T(7)
    );

  iobuf_282 : IOBUF
    port map (
      I => memory_bank0_data_O(8),
      IO => memory_bank0_data(8),
      O => memory_bank0_data_I(8),
      T => memory_bank0_data_T(8)
    );

  iobuf_283 : IOBUF
    port map (
      I => memory_bank0_data_O(9),
      IO => memory_bank0_data(9),
      O => memory_bank0_data_I(9),
      T => memory_bank0_data_T(9)
    );

  iobuf_284 : IOBUF
    port map (
      I => memory_bank0_data_O(10),
      IO => memory_bank0_data(10),
      O => memory_bank0_data_I(10),
      T => memory_bank0_data_T(10)
    );

  iobuf_285 : IOBUF
    port map (
      I => memory_bank0_data_O(11),
      IO => memory_bank0_data(11),
      O => memory_bank0_data_I(11),
      T => memory_bank0_data_T(11)
    );

  iobuf_286 : IOBUF
    port map (
      I => memory_bank0_data_O(12),
      IO => memory_bank0_data(12),
      O => memory_bank0_data_I(12),
      T => memory_bank0_data_T(12)
    );

  iobuf_287 : IOBUF
    port map (
      I => memory_bank0_data_O(13),
      IO => memory_bank0_data(13),
      O => memory_bank0_data_I(13),
      T => memory_bank0_data_T(13)
    );

  iobuf_288 : IOBUF
    port map (
      I => memory_bank0_data_O(14),
      IO => memory_bank0_data(14),
      O => memory_bank0_data_I(14),
      T => memory_bank0_data_T(14)
    );

  iobuf_289 : IOBUF
    port map (
      I => memory_bank0_data_O(15),
      IO => memory_bank0_data(15),
      O => memory_bank0_data_I(15),
      T => memory_bank0_data_T(15)
    );

  iobuf_290 : IOBUF
    port map (
      I => memory_bank0_data_O(16),
      IO => memory_bank0_data(16),
      O => memory_bank0_data_I(16),
      T => memory_bank0_data_T(16)
    );

  iobuf_291 : IOBUF
    port map (
      I => memory_bank0_data_O(17),
      IO => memory_bank0_data(17),
      O => memory_bank0_data_I(17),
      T => memory_bank0_data_T(17)
    );

  iobuf_292 : IOBUF
    port map (
      I => memory_bank0_data_O(18),
      IO => memory_bank0_data(18),
      O => memory_bank0_data_I(18),
      T => memory_bank0_data_T(18)
    );

  iobuf_293 : IOBUF
    port map (
      I => memory_bank0_data_O(19),
      IO => memory_bank0_data(19),
      O => memory_bank0_data_I(19),
      T => memory_bank0_data_T(19)
    );

  iobuf_294 : IOBUF
    port map (
      I => memory_bank0_data_O(20),
      IO => memory_bank0_data(20),
      O => memory_bank0_data_I(20),
      T => memory_bank0_data_T(20)
    );

  iobuf_295 : IOBUF
    port map (
      I => memory_bank0_data_O(21),
      IO => memory_bank0_data(21),
      O => memory_bank0_data_I(21),
      T => memory_bank0_data_T(21)
    );

  iobuf_296 : IOBUF
    port map (
      I => memory_bank0_data_O(22),
      IO => memory_bank0_data(22),
      O => memory_bank0_data_I(22),
      T => memory_bank0_data_T(22)
    );

  iobuf_297 : IOBUF
    port map (
      I => memory_bank0_data_O(23),
      IO => memory_bank0_data(23),
      O => memory_bank0_data_I(23),
      T => memory_bank0_data_T(23)
    );

  iobuf_298 : IOBUF
    port map (
      I => memory_bank0_data_O(24),
      IO => memory_bank0_data(24),
      O => memory_bank0_data_I(24),
      T => memory_bank0_data_T(24)
    );

  iobuf_299 : IOBUF
    port map (
      I => memory_bank0_data_O(25),
      IO => memory_bank0_data(25),
      O => memory_bank0_data_I(25),
      T => memory_bank0_data_T(25)
    );

  iobuf_300 : IOBUF
    port map (
      I => memory_bank0_data_O(26),
      IO => memory_bank0_data(26),
      O => memory_bank0_data_I(26),
      T => memory_bank0_data_T(26)
    );

  iobuf_301 : IOBUF
    port map (
      I => memory_bank0_data_O(27),
      IO => memory_bank0_data(27),
      O => memory_bank0_data_I(27),
      T => memory_bank0_data_T(27)
    );

  iobuf_302 : IOBUF
    port map (
      I => memory_bank0_data_O(28),
      IO => memory_bank0_data(28),
      O => memory_bank0_data_I(28),
      T => memory_bank0_data_T(28)
    );

  iobuf_303 : IOBUF
    port map (
      I => memory_bank0_data_O(29),
      IO => memory_bank0_data(29),
      O => memory_bank0_data_I(29),
      T => memory_bank0_data_T(29)
    );

  iobuf_304 : IOBUF
    port map (
      I => memory_bank0_data_O(30),
      IO => memory_bank0_data(30),
      O => memory_bank0_data_I(30),
      T => memory_bank0_data_T(30)
    );

  iobuf_305 : IOBUF
    port map (
      I => memory_bank0_data_O(31),
      IO => memory_bank0_data(31),
      O => memory_bank0_data_I(31),
      T => memory_bank0_data_T(31)
    );

  obuf_306 : OBUF
    port map (
      I => memory_bank0_clken_n_OBUF,
      O => memory_bank0_clken_n
    );

  obuf_307 : OBUF
    port map (
      I => memory_bank0_clk_OBUF,
      O => memory_bank0_clk
    );

  obuf_308 : OBUF
    port map (
      I => memory_bank0_cen_n_OBUF,
      O => memory_bank0_cen_n
    );

  obuf_309 : OBUF
    port map (
      I => memory_bank0_adv_ld_n_OBUF,
      O => memory_bank0_adv_ld_n
    );

  obuf_310 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(0),
      O => memory_bank0_addr_p(0)
    );

  obuf_311 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(1),
      O => memory_bank0_addr_p(1)
    );

  obuf_312 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(2),
      O => memory_bank0_addr_p(2)
    );

  obuf_313 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(3),
      O => memory_bank0_addr_p(3)
    );

  obuf_314 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(4),
      O => memory_bank0_addr_p(4)
    );

  obuf_315 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(5),
      O => memory_bank0_addr_p(5)
    );

  obuf_316 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(6),
      O => memory_bank0_addr_p(6)
    );

  obuf_317 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(7),
      O => memory_bank0_addr_p(7)
    );

  obuf_318 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(8),
      O => memory_bank0_addr_p(8)
    );

  obuf_319 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(9),
      O => memory_bank0_addr_p(9)
    );

  obuf_320 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(10),
      O => memory_bank0_addr_p(10)
    );

  obuf_321 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(11),
      O => memory_bank0_addr_p(11)
    );

  obuf_322 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(12),
      O => memory_bank0_addr_p(12)
    );

  obuf_323 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(13),
      O => memory_bank0_addr_p(13)
    );

  obuf_324 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(14),
      O => memory_bank0_addr_p(14)
    );

  obuf_325 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(15),
      O => memory_bank0_addr_p(15)
    );

  obuf_326 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(16),
      O => memory_bank0_addr_p(16)
    );

  obuf_327 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(17),
      O => memory_bank0_addr_p(17)
    );

  obuf_328 : OBUF
    port map (
      I => memory_bank0_addr_p_OBUF(18),
      O => memory_bank0_addr_p(18)
    );

  obuf_329 : OBUF
    port map (
      I => net_vcc0,
      O => PHY_slew2
    );

  ibuf_330 : IBUF
    port map (
      I => sys_rst,
      O => open
    );

  bufgp_331 : BUFGP
    port map (
      I => sys_clk,
      O => sys_clk_s
    );

  obuf_332 : OBUF
    port map (
      I => net_gnd0,
      O => RS232_req_to_send
    );

  obuf_333 : OBUF
    port map (
      I => net_vcc0,
      O => PHY_slew1
    );

  ibuf_334 : IBUF
    port map (
      I => zbt_clk_fbin,
      O => mem_clk_fbin
    );

  obuf_335 : OBUF
    port map (
      I => mem_clk_fbout,
      O => zbt_clk_fbout
    );

end architecture STRUCTURE;
