-------------------------------------------------------------------------------
-- zbt_access_ctrl_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library zbt_ac_v1_00_a;
use zbt_ac_v1_00_a.all;

entity zbt_access_ctrl_wrapper is
  port (
    Mem_CLK : in std_logic;
    emc_Mem_A : in std_logic_vector(0 to 31);
    emc_Mem_DQ_I : in std_logic_vector(0 to 31);
    emc_Mem_DQ_O : out std_logic_vector(0 to 31);
    emc_Mem_DQ_T : in std_logic_vector(0 to 31);
    emc_Mem_CEN : in std_logic_vector(0 to 4);
    emc_Mem_OEN : in std_logic_vector(0 to 4);
    emc_Mem_WEN : in std_logic;
    emc_Mem_BEN : in std_logic_vector(0 to 3);
    emc_Mem_ADV_LDN : in std_logic;
    emc_Mem_CKEN : in std_logic;
    bank0_Mem_CLK : out std_logic;
    bank0_Mem_A : out std_logic_vector(18 downto 0);
    bank0_Mem_CEN : out std_logic;
    bank0_Mem_OEN : out std_logic;
    bank0_Mem_WEN : out std_logic;
    bank0_Mem_BEN : out std_logic_vector(0 to 3);
    bank0_Mem_ADV_LDN : out std_logic;
    bank0_Mem_CKEN : out std_logic;
    bank1_Mem_CLK : out std_logic;
    bank1_Mem_A : out std_logic_vector(18 downto 0);
    bank1_Mem_CEN : out std_logic;
    bank1_Mem_OEN : out std_logic;
    bank1_Mem_WEN : out std_logic;
    bank1_Mem_BEN : out std_logic_vector(0 to 3);
    bank1_Mem_ADV_LDN : out std_logic;
    bank1_Mem_CKEN : out std_logic;
    bank2_Mem_CLK : out std_logic;
    bank2_Mem_A : out std_logic_vector(18 downto 0);
    bank2_Mem_CEN : out std_logic;
    bank2_Mem_OEN : out std_logic;
    bank2_Mem_WEN : out std_logic;
    bank2_Mem_BEN : out std_logic_vector(0 to 3);
    bank2_Mem_ADV_LDN : out std_logic;
    bank2_Mem_CKEN : out std_logic;
    bank3_Mem_CLK : out std_logic;
    bank3_Mem_A : out std_logic_vector(18 downto 0);
    bank3_Mem_CEN : out std_logic;
    bank3_Mem_OEN : out std_logic;
    bank3_Mem_WEN : out std_logic;
    bank3_Mem_BEN : out std_logic_vector(0 to 3);
    bank3_Mem_ADV_LDN : out std_logic;
    bank3_Mem_CKEN : out std_logic;
    bank4_Mem_CLK : out std_logic;
    bank4_Mem_A : out std_logic_vector(18 downto 0);
    bank4_Mem_CEN : out std_logic;
    bank4_Mem_OEN : out std_logic;
    bank4_Mem_WEN : out std_logic;
    bank4_Mem_BEN : out std_logic_vector(0 to 3);
    bank4_Mem_ADV_LDN : out std_logic;
    bank4_Mem_CKEN : out std_logic;
    bank0_Mem_DQ_I : in std_logic_vector(0 to 31);
    bank0_Mem_DQ_O : out std_logic_vector(0 to 31);
    bank0_Mem_DQ_T : out std_logic_vector(0 to 31);
    bank1_Mem_DQ_I : in std_logic_vector(0 to 31);
    bank1_Mem_DQ_O : out std_logic_vector(0 to 31);
    bank1_Mem_DQ_T : out std_logic_vector(0 to 31);
    bank2_Mem_DQ_I : in std_logic_vector(0 to 31);
    bank2_Mem_DQ_O : out std_logic_vector(0 to 31);
    bank2_Mem_DQ_T : out std_logic_vector(0 to 31);
    bank3_Mem_DQ_I : in std_logic_vector(0 to 31);
    bank3_Mem_DQ_O : out std_logic_vector(0 to 31);
    bank3_Mem_DQ_T : out std_logic_vector(0 to 31);
    bank4_Mem_DQ_I : in std_logic_vector(0 to 31);
    bank4_Mem_DQ_O : out std_logic_vector(0 to 31);
    bank4_Mem_DQ_T : out std_logic_vector(0 to 31)
  );
end zbt_access_ctrl_wrapper;

architecture STRUCTURE of zbt_access_ctrl_wrapper is

  component zbt_ac is
    port (
      Mem_CLK : in std_logic;
      emc_Mem_A : in std_logic_vector(0 to 31);
      emc_Mem_DQ_I : in std_logic_vector(0 to 31);
      emc_Mem_DQ_O : out std_logic_vector(0 to 31);
      emc_Mem_DQ_T : in std_logic_vector(0 to 31);
      emc_Mem_CEN : in std_logic_vector(0 to 4);
      emc_Mem_OEN : in std_logic_vector(0 to 4);
      emc_Mem_WEN : in std_logic;
      emc_Mem_BEN : in std_logic_vector(0 to 3);
      emc_Mem_ADV_LDN : in std_logic;
      emc_Mem_CKEN : in std_logic;
      bank0_Mem_CLK : out std_logic;
      bank0_Mem_A : out std_logic_vector(18 downto 0);
      bank0_Mem_CEN : out std_logic;
      bank0_Mem_OEN : out std_logic;
      bank0_Mem_WEN : out std_logic;
      bank0_Mem_BEN : out std_logic_vector(0 to 3);
      bank0_Mem_ADV_LDN : out std_logic;
      bank0_Mem_CKEN : out std_logic;
      bank1_Mem_CLK : out std_logic;
      bank1_Mem_A : out std_logic_vector(18 downto 0);
      bank1_Mem_CEN : out std_logic;
      bank1_Mem_OEN : out std_logic;
      bank1_Mem_WEN : out std_logic;
      bank1_Mem_BEN : out std_logic_vector(0 to 3);
      bank1_Mem_ADV_LDN : out std_logic;
      bank1_Mem_CKEN : out std_logic;
      bank2_Mem_CLK : out std_logic;
      bank2_Mem_A : out std_logic_vector(18 downto 0);
      bank2_Mem_CEN : out std_logic;
      bank2_Mem_OEN : out std_logic;
      bank2_Mem_WEN : out std_logic;
      bank2_Mem_BEN : out std_logic_vector(0 to 3);
      bank2_Mem_ADV_LDN : out std_logic;
      bank2_Mem_CKEN : out std_logic;
      bank3_Mem_CLK : out std_logic;
      bank3_Mem_A : out std_logic_vector(18 downto 0);
      bank3_Mem_CEN : out std_logic;
      bank3_Mem_OEN : out std_logic;
      bank3_Mem_WEN : out std_logic;
      bank3_Mem_BEN : out std_logic_vector(0 to 3);
      bank3_Mem_ADV_LDN : out std_logic;
      bank3_Mem_CKEN : out std_logic;
      bank4_Mem_CLK : out std_logic;
      bank4_Mem_A : out std_logic_vector(18 downto 0);
      bank4_Mem_CEN : out std_logic;
      bank4_Mem_OEN : out std_logic;
      bank4_Mem_WEN : out std_logic;
      bank4_Mem_BEN : out std_logic_vector(0 to 3);
      bank4_Mem_ADV_LDN : out std_logic;
      bank4_Mem_CKEN : out std_logic;
      bank0_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank0_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank0_Mem_DQ_T : out std_logic_vector(0 to 31);
      bank1_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank1_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank1_Mem_DQ_T : out std_logic_vector(0 to 31);
      bank2_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank2_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank2_Mem_DQ_T : out std_logic_vector(0 to 31);
      bank3_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank3_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank3_Mem_DQ_T : out std_logic_vector(0 to 31);
      bank4_Mem_DQ_I : in std_logic_vector(0 to 31);
      bank4_Mem_DQ_O : out std_logic_vector(0 to 31);
      bank4_Mem_DQ_T : out std_logic_vector(0 to 31)
    );
  end component;

begin

  zbt_access_ctrl : zbt_ac
    port map (
      Mem_CLK => Mem_CLK,
      emc_Mem_A => emc_Mem_A,
      emc_Mem_DQ_I => emc_Mem_DQ_I,
      emc_Mem_DQ_O => emc_Mem_DQ_O,
      emc_Mem_DQ_T => emc_Mem_DQ_T,
      emc_Mem_CEN => emc_Mem_CEN,
      emc_Mem_OEN => emc_Mem_OEN,
      emc_Mem_WEN => emc_Mem_WEN,
      emc_Mem_BEN => emc_Mem_BEN,
      emc_Mem_ADV_LDN => emc_Mem_ADV_LDN,
      emc_Mem_CKEN => emc_Mem_CKEN,
      bank0_Mem_CLK => bank0_Mem_CLK,
      bank0_Mem_A => bank0_Mem_A,
      bank0_Mem_CEN => bank0_Mem_CEN,
      bank0_Mem_OEN => bank0_Mem_OEN,
      bank0_Mem_WEN => bank0_Mem_WEN,
      bank0_Mem_BEN => bank0_Mem_BEN,
      bank0_Mem_ADV_LDN => bank0_Mem_ADV_LDN,
      bank0_Mem_CKEN => bank0_Mem_CKEN,
      bank1_Mem_CLK => bank1_Mem_CLK,
      bank1_Mem_A => bank1_Mem_A,
      bank1_Mem_CEN => bank1_Mem_CEN,
      bank1_Mem_OEN => bank1_Mem_OEN,
      bank1_Mem_WEN => bank1_Mem_WEN,
      bank1_Mem_BEN => bank1_Mem_BEN,
      bank1_Mem_ADV_LDN => bank1_Mem_ADV_LDN,
      bank1_Mem_CKEN => bank1_Mem_CKEN,
      bank2_Mem_CLK => bank2_Mem_CLK,
      bank2_Mem_A => bank2_Mem_A,
      bank2_Mem_CEN => bank2_Mem_CEN,
      bank2_Mem_OEN => bank2_Mem_OEN,
      bank2_Mem_WEN => bank2_Mem_WEN,
      bank2_Mem_BEN => bank2_Mem_BEN,
      bank2_Mem_ADV_LDN => bank2_Mem_ADV_LDN,
      bank2_Mem_CKEN => bank2_Mem_CKEN,
      bank3_Mem_CLK => bank3_Mem_CLK,
      bank3_Mem_A => bank3_Mem_A,
      bank3_Mem_CEN => bank3_Mem_CEN,
      bank3_Mem_OEN => bank3_Mem_OEN,
      bank3_Mem_WEN => bank3_Mem_WEN,
      bank3_Mem_BEN => bank3_Mem_BEN,
      bank3_Mem_ADV_LDN => bank3_Mem_ADV_LDN,
      bank3_Mem_CKEN => bank3_Mem_CKEN,
      bank4_Mem_CLK => bank4_Mem_CLK,
      bank4_Mem_A => bank4_Mem_A,
      bank4_Mem_CEN => bank4_Mem_CEN,
      bank4_Mem_OEN => bank4_Mem_OEN,
      bank4_Mem_WEN => bank4_Mem_WEN,
      bank4_Mem_BEN => bank4_Mem_BEN,
      bank4_Mem_ADV_LDN => bank4_Mem_ADV_LDN,
      bank4_Mem_CKEN => bank4_Mem_CKEN,
      bank0_Mem_DQ_I => bank0_Mem_DQ_I,
      bank0_Mem_DQ_O => bank0_Mem_DQ_O,
      bank0_Mem_DQ_T => bank0_Mem_DQ_T,
      bank1_Mem_DQ_I => bank1_Mem_DQ_I,
      bank1_Mem_DQ_O => bank1_Mem_DQ_O,
      bank1_Mem_DQ_T => bank1_Mem_DQ_T,
      bank2_Mem_DQ_I => bank2_Mem_DQ_I,
      bank2_Mem_DQ_O => bank2_Mem_DQ_O,
      bank2_Mem_DQ_T => bank2_Mem_DQ_T,
      bank3_Mem_DQ_I => bank3_Mem_DQ_I,
      bank3_Mem_DQ_O => bank3_Mem_DQ_O,
      bank3_Mem_DQ_T => bank3_Mem_DQ_T,
      bank4_Mem_DQ_I => bank4_Mem_DQ_I,
      bank4_Mem_DQ_O => bank4_Mem_DQ_O,
      bank4_Mem_DQ_T => bank4_Mem_DQ_T
    );

end architecture STRUCTURE;
