library IEEE;
use IEEE.STD_Logic_1164.all;
use IEEE.STD_Logic_arith.all;
use IEEE.STD_Logic_unsigned.all;

entity zbt_ac is
  
  port (
     
    Mem_CLK     : in            STD_LOGIC;  								-- memory clock
	   
    ---------- to OPB_EMC ------------------------------------------------------------
    emc_Mem_A       	: in     	STD_LOGIC_VECTOR(0 to 31);      -- address bus
    emc_Mem_DQ_I    	: in			STD_LOGIC_VECTOR(0 to 31);      -- emc data bus input
	 emc_Mem_DQ_O	  	: out	 		STD_LOGIC_VECTOR(0 to 31); 	  -- emc data bus output 
	 emc_Mem_DQ_T	  	: in			STD_LOGIC_VECTOR(0 to 31); 	  -- emc data bus output enable
    emc_Mem_CEN     	: in        STD_LOGIC_VECTOR(0 to 4);       -- chip select
    emc_Mem_OEN     	: in        STD_LOGIC_VECTOR(0 to 4);        -- output enable
    emc_Mem_WEN     	: in        STD_LOGIC;  							-- write enable
    emc_Mem_BEN     	: in        STD_LOGIC_VECTOR(0 to 3);  		-- byte enable
    emc_Mem_ADV_LDN 	: in        STD_LOGIC;  							-- advanced burst adress/load new address
    emc_Mem_CKEN    	: in        STD_LOGIC;  							--clock enable
   
    -------- to memory_bank0 -----------------------------------------------------------
    bank0_Mem_CLK     : out     STD_LOGIC;
    bank0_Mem_A       : out     STD_LOGIC_VECTOR(18 downto 0);  
    bank0_Mem_DQ_I    : in		  STD_LOGIC_VECTOR(0 to 31); 	 		-- bank0 data bus input
	 bank0_Mem_DQ_O    : out     STD_LOGIC_VECTOR(0 to 31); 			-- bank0 data bus output
	 bank0_Mem_DQ_T    : out     STD_LOGIC_VECTOR(0 to 31); 			-- bank0 data bus output enable
    bank0_Mem_CEN     : out     STD_LOGIC; 
    bank0_Mem_OEN     : out     STD_LOGIC; 
    bank0_Mem_WEN     : out     STD_LOGIC; 
    bank0_Mem_BEN     : out     STD_LOGIC_VECTOR(0 to 3);  
    bank0_Mem_ADV_LDN : out     STD_LOGIC;  
    bank0_Mem_CKEN    : out     STD_LOGIC;  
    
    -------- to memory_bank1 ------------------------------------------------------------
    bank1_Mem_CLK     : out     STD_LOGIC;
    bank1_Mem_A       : out     STD_LOGIC_VECTOR(18 downto 0); 
    bank1_Mem_DQ_I    : in		  STD_LOGIC_VECTOR(0 to 31); 	 		
	 bank1_Mem_DQ_O    : out     STD_LOGIC_VECTOR(0 to 31); 			
	 bank1_Mem_DQ_T    : out     STD_LOGIC_VECTOR(0 to 31); 			
    bank1_Mem_CEN     : out     STD_LOGIC;  
    bank1_Mem_OEN     : out     STD_LOGIC;  
    bank1_Mem_WEN     : out     STD_LOGIC;  
    bank1_Mem_BEN     : out     STD_LOGIC_VECTOR(0 to 3);  
    bank1_Mem_ADV_LDN : out     STD_LOGIC;  
    bank1_Mem_CKEN    : out     STD_LOGIC;
    
    -------- to memory_bank2 ------------------------------------------------------------
    bank2_Mem_CLK     : out     STD_LOGIC;
    bank2_Mem_A       : out     STD_LOGIC_VECTOR(18 downto 0);  
    bank2_Mem_DQ_I    : in		  STD_LOGIC_VECTOR(0 to 31); 	 		
	 bank2_Mem_DQ_O    : out     STD_LOGIC_VECTOR(0 to 31); 			
	 bank2_Mem_DQ_T    : out     STD_LOGIC_VECTOR(0 to 31); 	  
    bank2_Mem_CEN     : out     STD_LOGIC; 
    bank2_Mem_OEN     : out     STD_LOGIC;  
    bank2_Mem_WEN     : out     STD_LOGIC; 
    bank2_Mem_BEN     : out     STD_LOGIC_VECTOR(0 to 3); 
    bank2_Mem_ADV_LDN : out     STD_LOGIC;  
    bank2_Mem_CKEN    : out     STD_LOGIC;
    
    -------- to memory_bank3 -------------------------------------------------------------
    bank3_Mem_CLK     : out     STD_LOGIC;
    bank3_Mem_A       : out     STD_LOGIC_VECTOR(18 downto 0); 
    bank3_Mem_DQ_I    : in		  STD_LOGIC_VECTOR(0 to 31); 	 		
	 bank3_Mem_DQ_O    : out     STD_LOGIC_VECTOR(0 to 31); 			
	 bank3_Mem_DQ_T    : out     STD_LOGIC_VECTOR(0 to 31); 	 
    bank3_Mem_CEN     : out     STD_LOGIC;  
    bank3_Mem_OEN     : out     STD_LOGIC;  
    bank3_Mem_WEN     : out     STD_LOGIC; 
    bank3_Mem_BEN     : out     STD_LOGIC_VECTOR(0 to 3); 
    bank3_Mem_ADV_LDN : out     STD_LOGIC; 
    bank3_Mem_CKEN    : out     STD_LOGIC;

    ------- to memory_bank4 --------------------------------------------------------------
    bank4_Mem_CLK     : out     STD_LOGIC;
    bank4_Mem_A       : out     STD_LOGIC_VECTOR(18 downto 0); 
    bank4_Mem_DQ_I    : in		  STD_LOGIC_VECTOR(0 to 31); 	 		
	 bank4_Mem_DQ_O    : out     STD_LOGIC_VECTOR(0 to 31); 			
	 bank4_Mem_DQ_T    : out     STD_LOGIC_VECTOR(0 to 31); 	 
    bank4_Mem_CEN     : out     STD_LOGIC;  
    bank4_Mem_OEN     : out     STD_LOGIC;  
    bank4_Mem_WEN     : out     STD_LOGIC;  
    bank4_Mem_BEN     : out     STD_LOGIC_VECTOR(0 to 3);  
    bank4_Mem_ADV_LDN : out     STD_LOGIC;  
    bank4_Mem_CKEN    : out     STD_LOGIC);

end zbt_ac;

architecture behaviour of zbt_ac is
  signal sig_Mem_CLK : STD_LOGIC;
  signal sig_Mem_A : STD_LOGIC_VECTOR(31 downto 0);
  signal sig_Mem_DQ_to_zbt : STD_LOGIC_VECTOR(0 to 31);
  signal sig_Mem_DQ_tri : STD_LOGIC_VECTOR(0 to 31);
  signal sig_Mem_CEN : STD_LOGIC_VECTOR(0 to 4);
  signal sig_Mem_OEN : STD_LOGIC_VECTOR(0 to 4);
  signal sig_Mem_WEN : STD_LOGIC;
  signal sig_Mem_BEN : STD_LOGIC_VECTOR(0 to 3);
  signal sig_Mem_ADV_LDN : STD_LOGIC;
  signal sig_Mem_CKEN : STD_LOGIC; 

begin  -- behaviour

  sig_Mem_CLK           <= Mem_CLK;
  sig_Mem_A             <= emc_Mem_A(0 to 31);
  sig_Mem_DQ_tri 			<= emc_Mem_DQ_T(0 to 31);
  sig_Mem_DQ_to_zbt 		<= emc_Mem_DQ_I(0 to 31);
  sig_Mem_CEN           <= emc_Mem_CEN(0 to 4);
  sig_Mem_OEN           <= emc_Mem_OEN(0 to 4);
  sig_Mem_WEN           <= emc_Mem_WEN;
  sig_Mem_BEN           <= emc_Mem_BEN(0 to 3);
  sig_Mem_ADV_LDN       <= emc_Mem_ADV_LDN;
  sig_Mem_CKEN          <= emc_Mem_CKEN;
 

  select_data : process (emc_Mem_CEN)
  begin
	case emc_Mem_CEN is	-- which chip is enabled
		when "01111" =>
			emc_Mem_DQ_O <=  bank0_Mem_DQ_I(0 to 31);
		when "10111" =>
			emc_Mem_DQ_O <=  bank1_Mem_DQ_I(0 to 31);	
		when "11011" =>
			emc_Mem_DQ_O <=  bank2_Mem_DQ_I(0 to 31);	
		when "11101" =>
			emc_Mem_DQ_O <=  bank3_Mem_DQ_I(0 to 31);	
		when "11110" =>
			emc_Mem_DQ_O <=  bank4_Mem_DQ_I(0 to 31);
		when others =>		--should never happen
			emc_Mem_DQ_O <=  bank0_Mem_DQ_I(0 to 31);
	end case;				
  end process select_data;
    

  bank0_Mem_CLK         <= sig_Mem_CLK;
  bank0_Mem_A           <= sig_Mem_A(20 downto 2); 
  bank0_Mem_DQ_O 			<= sig_Mem_DQ_to_zbt (0 to 31);
  bank0_Mem_DQ_T			<= sig_Mem_DQ_tri (0 to 31);
  bank0_Mem_CEN         <= sig_Mem_CEN(0);
  bank0_Mem_OEN         <= sig_Mem_OEN(0);
  bank0_Mem_WEN         <= sig_Mem_WEN;
  bank0_Mem_BEN         <= sig_Mem_BEN(0 to 3);
  bank0_Mem_ADV_LDN     <= sig_Mem_ADV_LDN;
  bank0_Mem_CKEN        <= sig_Mem_CKEN;

  bank1_Mem_CLK         <= sig_Mem_CLK;
  bank1_Mem_A           <= sig_Mem_A(20 downto 2);
  bank1_Mem_DQ_O 			<= sig_Mem_DQ_to_zbt (0 to 31);
  bank1_Mem_DQ_T			<= sig_Mem_DQ_tri (0 to 31);
  bank1_Mem_CEN         <= sig_Mem_CEN(1);
  bank1_Mem_OEN         <= sig_Mem_OEN(1);
  bank1_Mem_WEN         <= sig_Mem_WEN;
  bank1_Mem_BEN         <= sig_Mem_BEN(0 to 3);
  bank1_Mem_ADV_LDN     <= sig_Mem_ADV_LDN;
  bank1_Mem_CKEN        <= sig_Mem_CKEN;

  bank2_Mem_CLK         <= sig_Mem_CLK;
  bank2_Mem_A           <= sig_Mem_A(20 downto 2);
  bank2_Mem_DQ_O 			<= sig_Mem_DQ_to_zbt (0 to 31);
  bank2_Mem_DQ_T			<= sig_Mem_DQ_tri (0 to 31);
  bank2_Mem_CEN         <= sig_Mem_CEN(2);
  bank2_Mem_OEN         <= sig_Mem_OEN(2);
  bank2_Mem_WEN         <= sig_Mem_WEN;
  bank2_Mem_BEN         <= sig_Mem_BEN(0 to 3);
  bank2_Mem_ADV_LDN     <= sig_Mem_ADV_LDN;
  bank2_Mem_CKEN        <= sig_Mem_CKEN;

  bank3_Mem_CLK         <= sig_Mem_CLK;
  bank3_Mem_A           <= sig_Mem_A(20 downto 2);
  bank3_Mem_DQ_O 			<= sig_Mem_DQ_to_zbt (0 to 31);
  bank3_Mem_DQ_T			<= sig_Mem_DQ_tri (0 to 31);
  bank3_Mem_CEN         <= sig_Mem_CEN(3);
  bank3_Mem_OEN         <= sig_Mem_OEN(3);
  bank3_Mem_WEN         <= sig_Mem_WEN;
  bank3_Mem_BEN         <= sig_Mem_BEN(0 to 3);
  bank3_Mem_ADV_LDN     <= sig_Mem_ADV_LDN;
  bank3_Mem_CKEN        <= sig_Mem_CKEN;

  bank4_Mem_CLK         <= sig_Mem_CLK;
  bank4_Mem_A           <= sig_Mem_A(20 downto 2);
  bank4_Mem_DQ_O 			<= sig_Mem_DQ_to_zbt (0 to 31);
  bank4_Mem_DQ_T			<= sig_Mem_DQ_tri (0 to 31);
  bank4_Mem_CEN         <= sig_Mem_CEN(4);
  bank4_Mem_OEN         <= sig_Mem_OEN(4);
  bank4_Mem_WEN         <= sig_Mem_WEN;
  bank4_Mem_BEN         <= sig_Mem_BEN(0 to 3);
  bank4_Mem_ADV_LDN     <= sig_Mem_ADV_LDN;
  bank4_Mem_CKEN        <= sig_Mem_CKEN;
  
end behaviour;
