#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:E:\proj\backup\ws_dec_2004\ws\system.xmp
#################################################################

XILINX_EDK_DIR = C:/EDA/EDK/

SYSTEM = system

MHSFILE = system.mhs

MSSFILE = system.mss

FPGA_ARCH = virtex2

DEVICE = XC2V2000FF896-4

LANGUAGE = vhdl

SEARCHPATHOPT = 

SUBMODULE_OPT = 

PLATGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(SUBMODULE_OPT)

LIBGEN_OPTIONS = -mhs $(MHSFILE) -p $(FPGA_ARCH) $(SEARCHPATHOPT) \
                   $(MICROBLAZE_0_LIBG_OPT)

MB0_DEFAULT_OUTPUT_DIR = mb0_default
MB0_DEFAULT_OUTPUT = $(MB0_DEFAULT_OUTPUT_DIR)/executable.elf

MEMTEST_OUTPUT_DIR = MemTest
MEMTEST_OUTPUT = $(MEMTEST_OUTPUT_DIR)/executable.elf

MICROBLAZE_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/microblaze/mb_bootloop.elf
PPC405_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc405/ppc_bootloop.elf
BOOTLOOP_DIR = bootloops

MICROBLAZE_0_BOOTLOOP = $(BOOTLOOP_DIR)/microblaze_0.elf
MICROBLAZE_0_XMDSTUB = microblaze_0/code/xmdstub.elf

BRAMINIT_ELF_FILES =   $(MICROBLAZE_0_XMDSTUB) 
BRAMINIT_ELF_FILE_ARGS =   -pe microblaze_0  $(MICROBLAZE_0_XMDSTUB) 

ALL_USER_ELF_FILES = $(MB0_DEFAULT_OUTPUT) $(MEMTEST_OUTPUT) 

SIM_CMD = vsim

BEHAVIORAL_SIM_SCRIPT = simulation/behavioral/$(SYSTEM).do

STRUCTURAL_SIM_SCRIPT = simulation/structural/$(SYSTEM).do

TIMING_SIM_SCRIPT = simulation/timing/$(SYSTEM).do

DEFAULT_SIM_SCRIPT = $(BEHAVIORAL_SIM_SCRIPT)

SIMGEN_OPTIONS = -p $(FPGA_ARCH) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(SUBMODULE_OPT) $(BRAMINIT_ELF_FILE_ARGS) -s mti

MICROBLAZE_0_XMDSTUB = microblaze_0/code/xmdstub.elf

LIBRARIES =  \
       microblaze_0/lib/libxil.a 

LIBSCLEAN_TARGETS = microblaze_0_libsclean 

PROGRAMCLEAN_TARGETS = mb0_default_programclean memtest_programclean 

CORE_STATE_DEVELOPMENT_FILES = 

WRAPPER_NGC_FILES = implementation/microblaze_0_wrapper.ngc \
implementation/mb_opb_wrapper.ngc \
implementation/debug_module_wrapper.ngc \
implementation/ilmb_wrapper.ngc \
implementation/dlmb_wrapper.ngc \
implementation/dlmb_cntlr_wrapper.ngc \
implementation/ilmb_cntlr_wrapper.ngc \
implementation/lmb_bram_wrapper.ngc \
implementation/rs232_wrapper.ngc \
implementation/opb_gpio_0_wrapper.ngc \
implementation/opb_timer_0_wrapper.ngc \
implementation/opb_intc_0_wrapper.ngc \
implementation/opb_ethernet_0_wrapper.ngc \
implementation/dcm_sysclk_wrapper.ngc \
implementation/emc_wrapper.ngc \
implementation/dcm_memclk_wrapper.ngc

POSTSYN_NETLIST = implementation/$(SYSTEM).ngc

SYSTEM_BIT = implementation/$(SYSTEM).bit

DOWNLOAD_BIT = implementation/download.bit

SYSTEM_ACE = implementation/$(SYSTEM).ace

UCF_FILE = data/$(SYSTEM).ucf

FASTRUNTIME_OPT_FILE = etc/fast_runtime.opt
BITGEN_UT_FILE = etc/bitgen.ut

#################################################################
# SOFTWARE APPLICATION MB0_DEFAULT
#################################################################

MB0_DEFAULT_SOURCES = code/web.c code/dhcp.c code/ip_out.c code/csock.c 

MB0_DEFAULT_HEADERS = code/web.h code/dhcp.h code/ip_out.h code/csock.h 

MB0_DEFAULT_CC = mb-gcc
MB0_DEFAULT_CC_SIZE = mb-size
MB0_DEFAULT_CC_OPT = -O0
MB0_DEFAULT_CFLAGS = 
MB0_DEFAULT_CC_SEARCH = # -B
MB0_DEFAULT_LIBPATH = -L./microblaze_0/lib/ # -L
MB0_DEFAULT_INCLUDES = -I./microblaze_0/include/  -Icode/ # -I
MB0_DEFAULT_LFLAGS = # -l
MB0_DEFAULT_CC_PREPROC_FLAG = # -Wp,
MB0_DEFAULT_CC_ASM_FLAG = # -Wa,
MB0_DEFAULT_CC_LINKER_FLAG =   -Wl,-defsym -Wl,_STACK_SIZE=0x10000 
MB0_DEFAULT_LINKER_SCRIPT = 
MB0_DEFAULT_LINKER_SCRIPT_FLAG = #-Wl,-T -Wl,$(MB0_DEFAULT_LINKER_SCRIPT) 
MB0_DEFAULT_CC_DEBUG_FLAG =  -g 
MB0_DEFAULT_CC_PROFILE_FLAG = # -pg
MB0_DEFAULT_CC_GLOBPTR_FLAG= # -mxl-gp-opt
MB0_DEFAULT_MODE = xmdstub
MB0_DEFAULT_LIBG_OPT = -$(MB0_DEFAULT_MODE) microblaze_0
MB0_DEFAULT_CC_SOFTMUL_FLAG= -mno-xl-soft-mul 
MB0_DEFAULT_CC_START_ADDR_FLAG= -Wl,-defsym -Wl,_TEXT_START_ADDR=0x81500000
MB0_DEFAULT_CC_STACK_SIZE_FLAG=  -Wl,-defsym -Wl,_STACK_SIZE=0x10000
MB0_DEFAULT_OTHER_CC_FLAGS= $(MB0_DEFAULT_CC_GLOBPTR_FLAG)  \
                  $(MB0_DEFAULT_CC_START_ADDR_FLAG) $(MB0_DEFAULT_CC_STACK_SIZE_FLAG)  \
                  $(MB0_DEFAULT_CC_SOFTMUL_FLAG)  \
                  $(MB0_DEFAULT_CC_PREPROC_FLAG) $(MB0_DEFAULT_CC_ASM_FLAG) $(MB0_DEFAULT_CC_LINKER_FLAG)  \
                  $(MB0_DEFAULT_LINKER_SCRIPT_FLAG) $(MB0_DEFAULT_CC_DEBUG_FLAG) $(MB0_DEFAULT_CC_PROFILE_FLAG) 

#################################################################
# SOFTWARE APPLICATION MEMTEST
#################################################################

MEMTEST_SOURCES = code/memtest.c 

MEMTEST_HEADERS = 

MEMTEST_CC = mb-gcc
MEMTEST_CC_SIZE = mb-size
MEMTEST_CC_OPT = -O0
MEMTEST_CFLAGS = 
MEMTEST_CC_SEARCH = # -B
MEMTEST_LIBPATH = -L./microblaze_0/lib/ # -L
MEMTEST_INCLUDES = -I./microblaze_0/include/ # -I
MEMTEST_LFLAGS = # -l
MEMTEST_CC_PREPROC_FLAG = # -Wp,
MEMTEST_CC_ASM_FLAG = # -Wa,
MEMTEST_CC_LINKER_FLAG = # -Wl,
MEMTEST_LINKER_SCRIPT = 
MEMTEST_LINKER_SCRIPT_FLAG = #-Wl,-T -Wl,$(MEMTEST_LINKER_SCRIPT) 
MEMTEST_CC_DEBUG_FLAG =  -g 
MEMTEST_CC_PROFILE_FLAG = # -pg
MEMTEST_CC_GLOBPTR_FLAG= # -mxl-gp-opt
MEMTEST_MODE = xmdstub
MEMTEST_LIBG_OPT = -$(MEMTEST_MODE) microblaze_0
MEMTEST_CC_SOFTMUL_FLAG= -mno-xl-soft-mul 
MEMTEST_CC_START_ADDR_FLAG=  # -Wl,-defsym -Wl,_TEXT_START_ADDR=
MEMTEST_CC_STACK_SIZE_FLAG=  # -Wl,-defsym -Wl,_STACK_SIZE=
MEMTEST_OTHER_CC_FLAGS= $(MEMTEST_CC_GLOBPTR_FLAG)  \
                  $(MEMTEST_CC_START_ADDR_FLAG) $(MEMTEST_CC_STACK_SIZE_FLAG)  \
                  $(MEMTEST_CC_SOFTMUL_FLAG)  \
                  $(MEMTEST_CC_PREPROC_FLAG) $(MEMTEST_CC_ASM_FLAG) $(MEMTEST_CC_LINKER_FLAG)  \
                  $(MEMTEST_LINKER_SCRIPT_FLAG) $(MEMTEST_CC_DEBUG_FLAG) $(MEMTEST_CC_PROFILE_FLAG) 
